{$I DebuggerAnAus.pas}
unit Unit10explorer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, FileCtrl, Menus;

type
  TForm10explorer = class(TForm)
    Panel1: TPanel;
    ListView1: TListView;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    DirectoryListBox1: TDirectoryListBox;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    RzuckzumHauptprogramm1: TMenuItem;
    Bearbeiten1: TMenuItem;
    SucheDatei1: TMenuItem;
    Loeschen1: TMenuItem;
    IndenTTTextpapierkorbverschieben1: TMenuItem;
    Endgltiglschen1: TMenuItem;
    EinfacheSuche1: TMenuItem;
    WindowsexplorerimausgewhltenOrdnerffnen1: TMenuItem;
    GanzeOrdnerlschen1: TMenuItem;
    Dosfensterffnen1: TMenuItem;
    Allesauswhlen1: TMenuItem;
    Extras1: TMenuItem;
    Programmstarten1: TMenuItem;
    Textvorschau1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Dateien1: TMenuItem;
    kopieren1: TMenuItem;
    einfgen1: TMenuItem;
    verschieben1: TMenuItem;
    Hinweis1: TMenuItem;
    N4: TMenuItem;
    Allesauswhlen2: TMenuItem;
    NeuenOrdnererzeugen1: TMenuItem;
    N1: TMenuItem;
    LeerenOrdnerlschen1: TMenuItem;
    ExplorerimmerimVordergrund1: TMenuItem;
    N5: TMenuItem;
    DateienmitOrdnereinfgen1: TMenuItem;
    AlleausgewhltenDateienffneb1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Allesauswhlen3: TMenuItem;
    Dateienvormerken1: TMenuItem;
    vorgemerkteDateienkopieren1: TMenuItem;
    vorgemerkteDateienverschieben1: TMenuItem;
    vorgemerkteDateienmitOrdnerkopieren1: TMenuItem;
    AlleausgewhltenDateienffnen1: TMenuItem;
    PopupMenu2: TPopupMenu;
    LeerenOrdnerlschen2: TMenuItem;
    NeuenOrdnererzeugen2: TMenuItem;
    Programmstarten2: TMenuItem;
    AlleausgewhltenDateienunwideruflichlschen1: TMenuItem;
    N6: TMenuItem;
    UPX1: TMenuItem;
    Beideexplorerzeigen1: TMenuItem;
    Explorer1: TMenuItem;
    AusgewhlteDateienumbenennen1: TMenuItem;
    N7: TMenuItem;
    Wieveilistnochfrei1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure DirectoryListBox1Click(Sender: TObject);
    procedure zeigeDateien(dir: string);
    procedure Netzauswerten;
    function Form10explorernr: char;
    procedure Form10explorerStart;
    procedure RzuckzumHauptprogramm1Click(Sender: TObject);
    procedure Platziere(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure SucheDatei1Click(Sender: TObject);
    procedure IndenTTTextpapierkorbverschieben1Click(Sender: TObject);
    procedure Endgltiglschen1Click(Sender: TObject);
    procedure EinfacheSuche1Click(Sender: TObject);
    procedure WindowsexplorerimausgewhltenOrdnerffnen1Click(
      Sender: TObject);
    procedure GanzeOrdnerlschen1Click(Sender: TObject);
    procedure Dosfensterffnen1Click(Sender: TObject);
    procedure Allesauswhlen1Click(Sender: TObject);
    procedure Programmstarten1Click(Sender: TObject);
    procedure Textvorschau1Click(Sender: TObject);
    procedure MasseInIniDateischreiben(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Hinweis1Click(Sender: TObject);
    procedure kopieren1Click(Sender: TObject);
    procedure einfgen1Click(Sender: TObject);
    procedure NeuenOrdnererzeugen1Click(Sender: TObject);
    procedure LeerenOrdnerlschen1Click(Sender: TObject);
    function AktuellDir: string;
    procedure ExplorerimmerimVordergrund1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DateienmitOrdnereinfgen1Click(Sender: TObject);
    procedure AlleausgewhltenDateienffneb1Click(Sender: TObject);
    procedure LeseUndSetzeForm10explorermasse(Sender: TObject);
    procedure SchreibeForm10explorermasse(Sender: TObject);
    procedure LeseUndSetzePanelmasse(Sender: TObject);
    procedure SchreibePanelmasse(Sender: TObject);
    procedure UPX1Click(Sender: TObject);
    procedure Beideexplorerzeigen1Click(Sender: TObject);
    procedure AusgewhlteDateienumbenennen1Click(Sender: TObject);
    procedure Wieveilistnochfrei1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
const NetzLaufwerk = 'Netz';
      sectionExplorer = 'Explorer';
      schluesselform10 = 'SchlsselExplorer';
      schluesselform10LF = 'Laufwerk';
      schluesselform10panel = 'Explorermae2';
      schluesselform10masse = 'Explorermae1';
      schluesselform10listviewmasse = 'Laufwerkskastenhoehe';
var
  Form10Explorer1: TForm10Explorer;
  Form10Explorer2: TForm10Explorer;
  gProgrammEtcStarten: String = '';


function dateinahmeOhneZusatz(const s: string): string;
procedure DateienEndgueltigloeschen(listbox: TListbox; dir: string);
Procedure indenPapierkorbverschieben(listbox: Tlistbox; dir: string);
function DeleteFile0(pfad: string): integer;

implementation

uses shellapi, unit1, Unit_ttText_hilf, Unit_ttText_ini, Unit_ttText_wav,
  Unit11_suchen, Unit12Meldung, unit8memo;
{$R *.DFM}

function TForm10Explorer.Form10explorernr: char;
begin
 try if pos('_1',self.name) > 0 then result := '2' else
   result := '1';
 except result := '1' End;
end;

procedure TForm10Explorer.LeseUndSetzeForm10explorermasse(Sender: TObject);
  var s: string;
begin
  s := leseIni(schluesselform10+Form10explorernr,schluesselform10masse+'top');
  if s > '' then top := StrToInt(s);
  s := leseIni(schluesselform10+Form10explorernr,schluesselform10masse+'left');
  if s > '' then left := StrToInt(s);
  s := leseIni(schluesselform10+Form10explorernr,schluesselform10masse+'width');
  if s > '' then width := StrToInt(s);
  s := leseIni(schluesselform10+Form10explorernr,schluesselform10masse+'height');
  if s > '' then height := StrToInt(s);
  s := LeseINi(schluesselform10+Form10explorernr,schluesselform10listviewmasse);
  if s > '' then listview1.height := StrToInt(s);
end;

procedure TForm10Explorer.SchreibeForm10explorermasse(Sender: TObject);
begin
  SchreibeIni(schluesselform10+Form10explorernr,schluesselform10masse+'top',IntToStr(top));
  SchreibeIni(schluesselform10+Form10explorernr,schluesselform10masse+'left',IntToStr(left));
  SchreibeIni(schluesselform10+Form10explorernr,schluesselform10masse+'width',IntToStr(width));
  SchreibeIni(schluesselform10+Form10explorernr,schluesselform10masse+'height',IntToStr(height));
  SchreibeIni(schluesselform10+Form10explorernr,schluesselform10listviewmasse,IntToStr(listview1.height));
end;


procedure TForm10Explorer.LeseUndSetzePanelmasse(Sender: TObject);
var k: integer;
    a: Tcomponent;
    b: TPanel;
    s: string;
begin
  for k := 0 to ComponentCount - 1 do Begin
     a := components[k];
     if a.ClassType = TPanel then with a as TPanel do Begin
        b := a as TPanel;
        s := leseIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'top');
        if s > '' then b.top := StrToInt(s);
        s := leseIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'left');
        if s > '' then b.left := StrToInt(s);
        s := leseIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'width');
        if s > '' then b.width := StrToInt(s);
        s := leseIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'height');
        if s > '' then b.height := StrToInt(s);
    End;
  End;
end;

procedure TForm10Explorer.SchreibePanelmasse(Sender: TObject);
var k: integer;
    a: Tcomponent;
    b: TPanel;
begin
  for k := 0 to ComponentCount - 1 do Begin
     a := components[k];
     if a.ClassType = TPanel then with a as TPanel do Begin
        b := a as TPanel;
        SchreibeIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'top',IntToStr(b.top));
        SchreibeIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'left',IntToStr(b.left));
        SchreibeIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'width', inttostr(b.width));
        SchreibeIni(schluesselform10+Form10explorernr,schluesselform10panel+a.name+'height',IntToStr(b.height));
    End;
  End;
end;


Procedure TForm10Explorer.Platziere(Sender: TObject);
begin
  Caption := 'Explorer ' + Form10explorernr;
  if sender = form1.Explorergro1 then Begin
    top := 40;
    if Form10explorernr = '2' then left := 0 else left := screen.Width div 2;
    height := screen.Height - 60;
    width := screen.Width div 2;
    panel1.width := width div 4;
    panel2.Width := (screen.Width div 2) - panel1.Width - 10;
    listview1.Height := (listview1.Items.Count+1) * 16;
    exit;
  End;
   if sender = form1.Dateiexplorerklein1 then Begin
    top := 40;
    if Form10explorernr = '2' then left := screen.Width - 800 else
      left := screen.Width - 400;
    height := 300;
    width := 400;
    panel1.Width := 150;
    panel2.Width := 250;
    listview1.Height := (listview1.Items.Count+1) * 16;
    exit;
  End;
  LeseUndSetzeForm10explorermasse(Sender);
  LeseUndSetzePanelmasse(Sender);
end;

procedure TForm10Explorer.Form10explorerStart;
  var pfad, LF: string;
begin
  show;
  LF := leseini(sectionExplorer+Form10explorernr,schluesselform10LF);
  if LF > '' then Begin
    pfad := leseini(sectionExplorer+Form10explorernr,schluesselform10+LF[1]);
    if pfad = '' then exit;
    try
      try 
        DirectoryListBox1.Directory := pfad
      except directorylistbox1.Directory := copy(pfad,1,3) End;
    except {Wechselplatte entfernt?} End;
    ZeigeDateien(pfad);
  End;
end;

procedure TForm10Explorer.zeigeDateien(dir: string);
    var SR: TSearchRec;
begin
  Listbox1.Items.Clear;
  try
    if dir = '' then exit;
    dir := IncludeTrailingBackslash(dir);
    if FindFirst(dir+'*.*',faAnyFile,SR)=0 then Begin
      repeat
        If ((sr.attr And faDirectory) = 0) and (SR.Name[1]<>'.') then
          InListboxEinfuegen(25,listbox1,sr.name,sr.size,FileDateToDateTime(sr.Time),sr.Attr);
      until FindNext(SR)<>0;
      FindClose(SR);
    End;
  except {dir existiert nicht} End;
end;


function GetCpuSpeed: Comp;
 var
   t: DWORD;
   mhi, mlo, nhi, nlo: DWORD;
   t0, t1, chi, clo, shr32: Comp;
 begin
   shr32 := 65536;
   shr32 := shr32 * 65536;

   t := GetTickCount;
   while t = GetTickCount do begin end;
   asm
     DB 0FH
     DB 031H
     mov mhi,edx
     mov mlo,eax
   end;

   while GetTickCount < (t + 1000) do begin end;
   asm
     DB 0FH
     DB 031H
     mov nhi,edx
     mov nlo,eax
   end;
   chi := mhi;
   clo := mlo;
   t0 := chi * shr32 + clo;
   chi := nhi;
   clo := nlo;
   t1 := chi * shr32 + clo;
   Result := (t1 - t0) / 1E6;
end;


function Memoryszustand: string;
  var  memory: TMEMORYSTATUS;
begin
  memory.dwLength := sizeof(memory);
  GlobalMemoryStatus(memory);
  result := 'physykalischer Arbeitsspeicher: ' + formatfloat('### ### ### ###.###',memory.dwTotalPhys) + ' Bytes'#13 +
            '                    davon frei: ' + formatfloat('### ### ### ###.###',memory.dwAvailPhys) + ' Bytes'#13 +
            'Virtueller Arbeitsspeicher    : ' +  formatfloat('### ### ### ###.###',memory.dwTotalPageFile) + ' Bytes'#13 +
            '                    davon frei: ' + formatfloat('### ### ### ###.###',memory.dwAvailPageFile) + ' Bytes'#13#13 +
            'CPU-Takt:' + formatfloat('### ### ### ###.###',GetCpuSpeed) + ' MHz';
end;


procedure LwTyp(drive: string; var volName, sysName, ID: string);
var VolumeName,
  FileSystemName: PChar;
  Seriennummer,
    MaxLen, SysFlags: DWord;
begin
  VolName := '';
  SysName := '';
  VolumeName := StrAlloc(256);
  FileSystemName := StrAlloc(256);
  if GetVolumeInformation(PChar(drive), VolumeName, 255,
    @Seriennummer, MaxLen, SysFlags, FilesystemName, 255) then Begin
    Volname := VolumeName;
    sysName := FileSystemname;
    ID := IntToStr(SerienNummer); //ss=IntToStr
  End;
  StrDispose(VolumeName);
  StrDispose(FileSystemName);
end;


procedure Laufwerke;
var i: integer;
  frei, belegt, gesamt, pfrei, pbelegt: extended;
  s, aktPfad,
    VolName, SysName,
    ID, LW: string;
  function typs(const i: integer): string;
  var typ: integer;
  begin try
      typ := GetDriveType(PChar(chr(i + 64) + ':\'));
      Case typ of Drive_Removable: result := 'Diskette';
        Drive_Fixed: result := 'Festplatte';
        Drive_CDROM: result := 'CDROM';
        DRIVE_RAMDISK: result := 'Ramdisk';
        Drive_REMOTE: result := 'Netzwerk';
      else result := ''; // 'Typ'+ss(typ)
      End
    except result := '' End;
  end;
begin
  frei := -1; //Nur fr Compiler
  s := Memoryszustand + #13#13;
  for i := 1 to 26 do Begin
    lw := typs(i);
    try
      gesamt := disksize(i);
    except gesamt := 0; End;
    if lw > '' then Begin
      LwTyp(char(i + 64) + ':\', volName, sysName, ID);
      try frei := diskfree(i); except continue End;
      belegt := gesamt - frei;
      getDir(i, aktPfad);
      pfrei := frei * 100 / gesamt;
      pbelegt := belegt * 100 / gesamt;
      s := s + #13 + plusspaces(lw, 10) + ' ' + plusspaces(chr(i + 64) + ' ' + VolName, 12)
        + plusspaces(' ' + sysName, 6);
      if gesamt > 0 then s := s + ' ID+Nr.:' + ID + '  aktueller Pfad:' + aktPfad + #13;
      s := s + '  Gesamt ' + formatfloat('### ### ### ###.###',gesamt);
      if gesamt > 0 then s := s + #13
          + plusspaces('  Belegt ' + formatfloat('### ### ### ###.###',belegt), 25)
          + plusspaces(' = ' + FloatToStrf(pbelegt, ffFixed, 3, 1) + '%', 7) + #13
          + plusspaces('  Frei   ' + formatfloat('### ### ### ###.###',frei), 25)
          + plusspaces(' = ' + FloatToStrf(pfrei, ffFixed, 3, 1) + '%', 7) + #13
    End;
  End;
  BearbeiteForm8('Laufwerke',s);
end;


procedure TForm10explorer.FormCreate(Sender: TObject);
var i, typ: Integer;
    s      : String;
    NewItem : TListItem;
begin
    Platziere(Sender);
    NewItem := ListView1.Items.Add;
    NewItem.Caption := NetzLaufwerk;
    For i := 0 To 25 do  Begin
        s :=  Chr(i + 65) + ':\';
        typ := GetDriveType(PChar(s));
        CAse Typ of
          DRIVE_REMOVABLE : begin
                              NewItem := ListView1.Items.Add;
                              NewItem.Caption := Chr(i + 65) + ': Entfernbar ';
                            end;
          DRIVE_FIXED     : begin
                              NewItem := ListView1.Items.Add;
                              NewItem.Caption :=  Chr(i + 65) + ': Festplatte';
                            end;
          DRIVE_CDROM     : begin
                              NewItem := ListView1.Items.Add;
                              NewItem.Caption :=  Chr(i + 65) + ': CDROM';
                            end;
          DRIVE_RAMDISK   : begin
                              NewItem := ListView1.Items.Add;
                              NewItem.Caption :=  Chr(i + 65) + ': RAMDisk';
                            end;
          DRIVE_REMOTE    : begin
                              NewItem := ListView1.Items.Add;
                              NewItem.Caption :=  Chr(i + 65) + ': Netzlaufwerk';
                            end;
        ENd;
    End;
end;

procedure TForm10explorer.Netzauswerten;
var dir: string;
begin
  try
    if SelectDirectory('Laufwerk und Ordner auswhlen.'#13 +'Dann:"OK" anklicken.', '',
      dir) then
      try
        DirectoryListBox1.Directory := dir
      except directorylistbox1.Directory := copy(dir,1,3) End;
  except ok('Auf das Verzeichnis kann zur Zeit nicht zugegriffen werden!'); End;
end;

procedure TForm10explorer.ListView1Click(Sender: TObject); //KLick auf Laufwerk
   var dir,pfad: String;
begin
  if listview1.Items.Count = 0 then exit;
  if Listview1.selected = nil then exit;
  if Listview1.selected.caption = NetzLaufwerk then Netzauswerten else
  try
    dir :=  Listview1.selected.caption[1] + ':\';
    pfad := leseini(sectionExplorer+Form10explorernr,schluesselform10+dir[1]);
    if pfad = '' then pfad := dir;
    try
      DirectoryListBox1.Directory := pfad
    except directorylistbox1.Directory := dir End;
    ZeigeDateien(pfad);
    schreibeini(sectionExplorer+Form10explorernr,schluesselform10LF,pfad[1]);
  except ok(dir + ' nicht betriebsbereit.') End;
end;

procedure TForm10explorer.DirectoryListBox1Click(Sender: TObject); //KLick auf Ordner
  var pfad: string;
begin
  try
    pfad := AktuellDir;
    ZeigeDateien(pfad);
    Schreibeini(sectionExplorer+Form10explorernr,schluesselform10+pfad[1],pfad);
  except ok('Auf den Ordner kann zur Zeit nicht zugegriffen werden!') end;
end;

procedure TForm10explorer.RzuckzumHauptprogramm1Click(Sender: TObject);
begin
  close;
end;

procedure TForm10explorer.MasseInIniDateischreiben(Sender: TObject);
  var pfad: string;
begin
   pfad := AktuellDir;
   SchreibePanelmasse(Sender);
   SchreibeForm10explorermasse(Sender);
   schreibeini(sectionExplorer+Form10explorernr,schluesselform10LF,pfad[1]);
   Schreibeini(sectionExplorer+Form10explorernr,schluesselform10+pfad[1],pfad);
end;

procedure TForm10explorer.FormDestroy(Sender: TObject);
begin
  MasseInIniDateischreiben(Sender); //Sptestens jetzt
end;

function dateinahmeOhneZusatz(const s: string): string;
begin
  if pos('|',s) = 0 then result := s else
    result := trim(copy(s,1, pos('|',s)-1));
end;

function vollerpfad(const dir,s: string): string;
begin
  result := dir;
  if result > '' then result := IncludeTrailingBackslash(result);
  result := result +  dateinahmeOhneZusatz(s);
end;

procedure TForm10explorer.ListBox1DblClick(Sender: TObject);
  var pfad: string;
  procedure start;
    begin
     gProgrammEtcStarten := lowercase(extractfileext(pfad));
     chdir(pfad); //Pfad muss gewechselt werden
     if  ShellExecute(application.handle,
         Pchar('open'),
         Pchar(extractFilename(Pfad)),
         Pchar(gParameter),
         Pchar(extractFilepath(pfad)),
         sw_ShowNormal) < 32 then
           okfehler('Nicht gestartet');
    end;
begin
  With listbox1 do Begin
    if itemindex < 0 then exit;  //gibts nicht
    pfad := vollerpfad(AktuellDir,Items[ItemIndex]);
    if exe_Etc_Datei(pfad) then Begin
      if gProgrammEtcStarten = lowercase(extractfileext(pfad)) then start
      else if frage('Programm (dazu) "' + pfad + '" starten?'#13+
                '(Rckfrage einmal pro Sitzung)') then start;
      exit;
    End;
    OffneDatei(pfad);
  End;
end;

procedure TForm10explorer.SucheDatei1Click(Sender: TObject);
begin
  with form11_suchen do Begin
  edit7.text := AktuellDir;
  show;
  End;
end;

function DeleteFile0(pfad: string): integer;
  var b: boolean;
begin
  result := 0; //ok
  b := DeleteFile(pfad);
  if b then exit;
  if FilesetAttr(pfad, 32) <> 0 then Begin
    okfehler('Attribut von ' + pfad + ' konnte nicht zum Lschen verndert werden!');
    result := -1;
    exit;
  end;
  b := deleteFile(pfad);
  if not b then Begin ok('"' + pfad+ '" konnte nicht gelscht werden');
    result := -1;
  End;
end;

Procedure indenPapierkorbverschieben(listbox: Tlistbox; dir: string);
  var pu: Tstringlist;
      k: integer;
begin
  pu := Tstringlist.Create;
  try
    with listbox do
    for k := 0 to items.Count - 1 do
      if Selected[k] then pu.Add(vollerpfad(dir,items[k]));
   if pu.Count = 0 then Begin
     ok('Die zu lschenden Dateien zuerst auswhlen!');
     exit;
   End;
   If MeldungsfensterOk('Dateien in den Papierkorb verschieben',
   '                         Folgende Dateien werden gelscht,'#13#10#13#10+
   'Im Papierkorb befindet sich dann jedoch je eine Sicherungskopie.'#13#10+
   'Datei "c:\test\xyz\a.html" unter dem Namen "c__test_xyz_a.html".'#13#10+
   'Den Papierkorb finden Sie mit Men "Bearbeiten|Einstellungen".',pu.text) then Begin
     VorUndNachabbruchknopfgedrueckt;
     for k := 0 to pu.count - 1 do BEgin
         if abbruchknopfgedrueckt(pu[k] + ' wird gelscht') then exit;
         try
           if pos(gpapierkorb,pu[k]) > 0 then BEGin
             okfehler('Dateien, deren Pfad "' + gpapierkorb + '"enthlt, '+
                'knnen nicht in den Papierkorb verschoben werden.');
             exit;
           END;
           KopiereDateiIndenPapierkorb(pu[k]);
           DeleteFile0(pu[k]);
         except okfehler('Fehler beim Lschen der Datei "' + pu[k]) END;
       End;
     End else ok('Abbruch');
  finally VorUndNachabbruchknopfgedrueckt; pu.Free End;
end;



procedure TForm10explorer.IndenTTTextpapierkorbverschieben1Click(Sender: TObject);
begin
  indenPapierkorbverschieben(listbox1,AktuellDir);
  DirectoryListBox1Click(nil);
end;

procedure DateienEndgueltigloeschen(listbox: TListbox; dir: string);
  var pu: Tstringlist;
      k: integer;
begin
  pu := Tstringlist.Create;
  try
    with listbox do
    for k := 0 to items.Count - 1 do
      if Selected[k] then pu.Add(vollerpfad(dir,items[k]));
    if pu.Count = 0 then Begin
      ok('Die zu lschenden Dateien zuerst auswhlen!');
      exit;
    End;
    If MeldungsfensterOk('Dateien endgltig lschen.',
          '                         Folgende Dateien werden gelscht,'#13#10#13#10+
          'Warnung: Sie sind in keinem Papierkorb mehr zu finden!', pu.text)
     then Begin
       VorUndNachabbruchknopfgedrueckt;
       for k := 0 to pu.count - 1 do BEgin
       if abbruchknopfgedrueckt(pu[k] + ' wird gelscht') then exit;
         try
           DeleteFile0(pu[k]);
         except okfehler('Fehler beim Lschen der Datei "' + pu[k]) END;
       ENd;
    End else ok('Abbruch');
  finally VorUndNachabbruchknopfgedrueckt; pu.Free End;
end;

procedure TForm10explorer.Endgltiglschen1Click(Sender: TObject);
begin
  DateienEndgueltigloeschen(listbox1, AktuellDir);
  DirectoryListBox1Click(nil);
end;

procedure TForm10explorer.EinfacheSuche1Click(Sender: TObject);
  var k: integer;
begin
  gsuchtext := inputbox('Suchen','Welche Dateien suchen Sie?',gsuchtext);
  for k := 0 to listbox1.Items.Count - 1 do
    if str1IstInStr2(gsuchtext,dateinahmeOhneZusatz(listbox1.items[k])) then
      listbox1.Selected[k] := true else listbox1.Selected[k] := false;
end;

procedure TForm10explorer.WindowsexplorerimausgewhltenOrdnerffnen1Click( Sender: TObject);
  var pfad: string;
begin
  pfad := AktuellDir;
  if ShellExecute(application.handle,
                    Pchar('explore'),
                    Pchar(pfad),
                    Nil,
                    Pchar(pfad),
                    sw_ShowNormal) <  32 then ok('Fehlgeschlagen');
end;
procedure TForm10explorer.GanzeOrdnerlschen1Click(Sender: TObject);
begin
  ok('Bitte lschen Sie die Ordner mit dem folgenden Windowsexplorer! '+
  'Klicken Sie dabei den Ordner an. Ein KLick auf die rechte Maustaste '+
  'ermglicht Ihnen das Lschen.');
  WindowsexplorerimausgewhltenOrdnerffnen1Click(nil);
end;


function CommandCom0: string;
var cmdbuffer: array[0..MAX_PATH] of Char;
    pfad: string;
begin
  GetEnvironmentVariable('COMSPEC', cmdBUffer, SizeOf(cmdBuffer));
  pfad := cmdbuffer;
  if fileexists(pfad) then result := pfad else Begin
    result := '';
    ok('Betriebssystem hat kein Dos mehr!');
  End;
end;

function WINDOWSPFAD: string;
var p: Pchar;
begin
  P := StrAlloc(MAX_PATH + 1);
  try
    GetWindowsDirectory(P, MAX_PATH + 1);
    result := p;
  finally StrDispose(P) End;
end;

procedure DOS_FENSTER;
var p: pchar;
begin
  p := pChar(CommandCom0 + ' /k lh ' + WINDOWSPFAD + '\command\doskey');
  if winExec(p, sw_show) < 32 then Begin
    ChDir(paramstr(0)[1] + ':\');
    winExec(p, sw_show);
  End;
end;

procedure TForm10explorer.Dosfensterffnen1Click(Sender: TObject);
begin
  chdir(AktuellDir);
  dos_Fenster;
end;


procedure TForm10explorer.Allesauswhlen1Click(Sender: TObject);
  var k: integer;
begin
  for k := 0 to listbox1.Items.Count - 1 do
    listbox1.Selected[k] := true;
end;

procedure TForm10explorer.Programmstarten1Click(Sender: TObject);
var i: integer;
  pfad, name, vorgang: string; //Achtung name in Classes
begin
  vorgang := 'open';
  try
    With listbox1 do Begin
      if itemindex < 0 then exit;  //gibts nicht
      pfad := vollerpfad(AktuellDir,Items[ItemIndex]);
    End;
    name := extractFilename(Pfad);
    pfad := extractFilepath(pfad); //Jetzt nur Pfad
    if gparameter = '' then gParameter := '/?';
    if not inputquery('Parameter','Falls ntig',gparameter) then exit;
    chdir(pfad); //Pfad muss gewechselt werden
    i := ShellExecute(application.handle,
         Pchar(vorgang),
         Pchar(name),
         Pchar(gParameter),
         Pchar(Pfad),
         sw_ShowNormal);
     if i < 32 then
        i := ShellExecute(application.handle,
        Pchar(vorgang),
        Pchar(pfad),
        Nil,
        Pchar(pfad),
        sw_ShowNormal);
    if i < 32 then ok('Programm zu ffnen unbekannt (1)!');
  except  ok('Programm zu ffnen unbekannt! (2)'); End;
end;

procedure TForm10explorer.Textvorschau1Click(Sender: TObject);
const ChunkSize: Longint = 8192*8; { copy in 64K chunks }
var
  CopyBuffer: Pchar; { buffer for copying }
  BytesCopied: Longint;
  Source: Integer; { handle }
  i,zaehl: integer;
  s, pfad: string;
begin
   With listbox1 do Begin
    if itemindex < 0 then BEgin
      ok('Datei auswhlen');
      exit;
    ENd;
    pfad := vollerpfad(AktuellDir,Items[ItemIndex]);
  End;
  GetMem(CopyBuffer, ChunkSize); { allocate the buffer }
  Source := FileOpen(Pfad, fmShareDenyWrite); { open source file }
  try
    if Source < 0 then Begin okfehler('Datei konnte nicht geffnet werden'); exit End;
    zaehl := 0;
    repeat
      inc(Zaehl);
      BytesCopied := FileRead(Source, CopyBuffer^, ChunkSize); { read chunk }
      s := '';
      for i := 1 to BytesCopied do Begin
        inc(zaehl);
        if  CopyBuffer[i - 1] = #13 then zaehl := 0;
        if zaehl > 80 then Begin
         s := s + #13#10;
         zaehl := 0;
        End;
        if CopyBuffer[i - 1] in [#13, #32..#255] then s := s + CopyBuffer[i - 1];
      End;
      if not MeldungsfensterOk('Lese',
        'Falls keine ASCII-Datei werden nur die ASCII-Zeichen dargestellt.',s)
          then exit;
    until BytesCopied < ChunkSize; { until we run out of chunks }
  finally
    FileClose(Source); { close the source file }
    FreeMem(CopyBuffer, ChunkSize); { free the buffer }
  End;
end;


procedure TForm10explorer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   MasseInIniDateischreiben(Sender);
   formstyle := fsnormal;
end;

procedure TForm10explorer.Hinweis1Click(Sender: TObject);
begin
   ok('TTText verfgt ber einen eigenen Puffer fr die Namen von Dateipfaden.'#13+
      'Sie knnen markierte Dateien in den Puffer nehmen ("vormerken") und anschlieend '+
      'diese Dateien in einen anderen Ordner kopieren (dann sind sie zwei mal vorhanden), '+
      'oder verschieben.'#13#13+
      'Den eigentlichen Vorgang mssen Sie jeweils noch besttigen.'#13#13+
      'Mit Hilfe des zweiten Explorers wird Ihre Arbeit gewaltig vereinfacht.');
end;

procedure TForm10explorer.kopieren1Click(Sender: TObject);
  var k: integer;
begin
  Form10Explorerpuffer.Clear;
  with listbox1 do
    for k := 0 to items.Count - 1 do
      if Selected[k] then Form10Explorerpuffer.Add((vollerpfad(AktuellDir,items[k])));
   if Form10Explorerpuffer.Count = 0 then Begin
     ok('Die vorzumerkenden Dateien zuerst auswhlen!');
     exit;
   End;
end;

procedure TForm10explorer.einfgen1Click(Sender: TObject);
  var k: integer;
      nach, Meldung: string;
      pu: Tstringlist;
begin
  If MeldungsfensterOk('Dateien kopieren.',
     'In den Ordner '#13#10#13#10+
     AktuellDir +
     #13#10#13#10'werden folgende Dateien eingefgt.',
     Form10Explorerpuffer.text) then Begin
       if Form10Explorerpuffer.Count = 0 then BEgin
         ok('Noch keine Dateien ausgewhlt!');
         exit;
       ENd;
       pu := Tstringlist.Create;
       try
         VorUndNachabbruchknopfgedrueckt;
         for k := 0 to Form10Explorerpuffer.Count - 1 do BEGin
           if abbruchknopfgedrueckt(Form10explorerpuffer[k]) then exit;
           nach := AktuellDir;
           nach := IncludeTrailingBackslash(nach);
           nach := nach + extractfilename(Form10Explorerpuffer[k]);
           meldung := DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(Form10Explorerpuffer[k], nach);
           if meldung = 'Abbruch' then beGin
              ok('Abbruch');
              exit;
           enD;
           if meldung > '' then
             okfehler('Datei "' + nach + '" konnte geschrieben werden werden.') else
               if (sender = verschieben1) or (sender = vorgemerkteDateienverschieben1)
                  then pu.add(Form10Explorerpuffer[k]);
         End;
         DirectoryListBox1Click(nil);
         if pu.Count > 0 then
           If not MeldungsfensterOk('Lschen der ursprnlichen Dateien',
             'Nachdem die Dateien erfolgreich in den neuen Ordner kopert wurden'#13+
             'knnen nun folgende Dateien gelscht werden:',pu.text) then BEgin
               ok('Abbruch!');
               exit;
             ENd;
         for k := 0 to pu.Count - 1 do  DeleteFile0(pu[k]);
       finally VorUndNachabbruchknopfgedrueckt; pu.free end;
     End else ok('Abbruch');
end;


procedure TForm10explorer.NeuenOrdnererzeugen1Click(Sender: TObject);
  var pfad: string;
begin
  if DirectoryListBox1.itemindex >= 0 then
    pfad := AktuellDir;
    selectDirectory(pfad, [sdAllowCreate, sdPerformcreate, sdPrompt], 0);
    DirectoryListBox1.Update;
    zeigeDateien(AktuellDir);
end;

function hoehereEbene(const pfad: string): string;
var k: integer;
begin
  k := length(pfad) - 1;
  while (k > 0) and (pfad[k] <> '\') do dec(k);
  if k >= 3 then result := copy(pfad, 1, k) else result := pfad;
end;

function TForm10explorer.AktuellDir: string;
begin
 result := DirectoryListBox1.GetItemPath(DirectoryListBox1.itemindex);
end;

procedure TForm10explorer.LeerenOrdnerlschen1Click(Sender: TObject);
begin
  chDir(copy(AktuellDir, 1, 3));
  {$I+}
  try   rmDir(AktuellDir);
  except okfehler('Zuerst alle Dateien im Ordner lschen!') End;
  try
    DirectoryListBox1.Directory := hoehereEbene(AktuellDir);
    except directorylistbox1.Directory := copy(AktuellDir,1,3) End;
  DirectoryListBox1.update;
  ZeigeDateien(AktuellDir);
end;



procedure TForm10explorer.ExplorerimmerimVordergrund1Click(
  Sender: TObject);
begin
  Form10explorer1.formstyle := fsstayonTop;
  Form10explorer2.formstyle := fsstayonTop;
end;

procedure TForm10explorer.FormResize(Sender: TObject);
begin
   if width < 75 then width := 75;
  end;

procedure TForm10explorer.DateienmitOrdnereinfgen1Click(Sender: TObject);
begin
  ok('Dateien mit der kompletten Ordnerstruktur knnen Sie ber Men '+
  '"Suche|Suche in Dateien" kopieren.'#13+
  'Achten Sie darauf, dass "Auch alle Unterordner durchsuchen" aktiviert ist'#13#13+
  'Alle Dateien kopieren: Vor "Start Suche" bitte "Alle Eingaben lschen" anklicken!');
  form11_suchen.CheckBox1.Checked := true;
  SucheDatei1Click(nil);
end;

procedure TForm10explorer.AlleausgewhltenDateienffneb1Click(Sender: TObject);
var pfad: string;
      k: integer;
begin
  With listbox1 do Begin
    if itemindex < 0 then exit;  //gibts nicht
    for k := 0 to listbox1.Items.Count - 1 do
      if listbox1.Selected[k] then Begin
        pfad := vollerpfad(AktuellDir,Items[k]);
        OffneDatei(pfad);
      End;
  End;
end;


procedure TForm10explorer.UPX1Click(Sender: TObject);
  var upx, pfad: string;
      i: integer;
begin
  upx := ExtractFileDir(paramstr(0))+'\upx.exe';
  if not fileexists(upx) then Begin
     okfehler('Nicht gefunden:' + upx+#13+
              '(Das Programm UPX.EXE muss im selben Ordner wie TTText.EXE sein!)');
     exit;
  End;
  if listbox1.SelCount <> 1 then Begin
     okfehler('Sie mssen genau eine Date auswhlen');
     exit;
  end;
  pfad := vollerpfad(AktuellDir,listbox1.Items[listbox1.ItemIndex]);
  if lowerCase(extractfileext(pfad)) <> '.exe' then Begin
    okfehler('Es muss sich um eine EXE-Datei handeln');
    exit;
  End;
  i := ShellExecute(application.handle,
      Pchar('open'),
      Pchar(upx),
      Pchar('--best '+pfad),
      Pchar(''),
      sw_ShowNormal);
   if i < 32 then okfehler('Kein Erfolg!');
end; 

procedure TForm10explorer.Beideexplorerzeigen1Click(Sender: TObject);
begin
  Form10explorer1.Show;
  Form10explorer2.show;
end;

procedure Dateienumbenennen(listbox: TListbox; dir: string);
  var pu: Tstringlist;
      k: integer;
begin
  pu := Tstringlist.Create;
  try
    with listbox do
    for k := 0 to items.Count - 1 do
      if Selected[k] then pu.Add(vollerpfad(dir,items[k]));
    if pu.Count = 0 then Begin
      ok('Die zu umbenennenden Dateien zuerst auswhlen!');
      exit;
    End;
    If MeldungsfensterOk('Dateien umbenennen',
          '                         Folgende Dateien konnen umbenannt werden,'#13#10#13#10+
          'berschreiben Sie einfach den alten Dateinamen!'#13+
          'Dateien, die nicht umbenannt werden sollen, stehen lassen!', pu.text)
     then Begin
       VorUndNachabbruchknopfgedrueckt;
       for k := 0 to pu.count - 1 do BEgin
       if abbruchknopfgedrueckt(pu[k] + ' wird umbenannt') then exit;
         if  k < Form12Meldung.Memo2.lines.count then
         if pu[k] <> Form12Meldung.Memo2.lines[k] then
           if RenameFile(pu[k], Form12Meldung.Memo2.lines[k]) = false then
             okfehler('Fehler beim Umbenennen der Datei "' + pu[k] + #13 +
                      'Mgliche Ursachen: Datei schon vorhanden'#13+
                      'Dateiordner mu gleich bleiben.');
       ENd;
    End else ok('Abbruch');
  finally VorUndNachabbruchknopfgedrueckt; pu.Free End;
end;


procedure TForm10explorer.AusgewhlteDateienumbenennen1Click(
  Sender: TObject);
begin
  Dateienumbenennen(listbox1, AktuellDir);
  DirectoryListBox1Click(nil);
end;

procedure TForm10explorer.Wieveilistnochfrei1Click(Sender: TObject);
begin
  Laufwerke;
end;

end.
