{$I DebuggerAnAus.pas}
unit Unit11_suchen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm11_suchen = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label3: TLabel;
    Edit7: TEdit;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    B_und_Oder: TButton;
    Label4: TLabel;
    Edit8: TEdit;
    Label5: TLabel;
    LAnzahl: TLabel;
    Label6: TLabel;
    LBytes: TLabel;
    LPfad: TLabel;
    MainMenu1: TMainMenu;
    zurck1: TMenuItem;
    ImmerimVordergrund1: TMenuItem;
    Eingabelschen1: TMenuItem;
    DateienmitOrdnerkopieren1: TMenuItem;
    Extras1: TMenuItem;
    Button1: TButton;
    Kopieren1: TMenuItem;
    Allesauswahlen1: TMenuItem;
    Lschen1: TMenuItem;
    IndenTTTextpapierkorbverschieben1: TMenuItem;
    Endgltiglschen1: TMenuItem;
    Allesauswhlen1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure B_und_OderClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ImmerimVordergrund1Click(Sender: TObject);
    procedure zurck1Click(Sender: TObject);
    procedure Allesauswahlen1Click(Sender: TObject);
    procedure IndenTTTextpapierkorbverschieben1Click(Sender: TObject);
    procedure Endgltiglschen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form11_suchen: TForm11_suchen;
  AnzahlDateien, AnzahlBytes: integer;

implementation
uses shellapi, FileCtrl, unit1, Unit10explorer, Unit12Meldung, unit14abbrechen,
     Unit_ttText_wav, Unit_ttText_hilf;
{$R *.DFM}


function istInderDatei(const s: string; const pfad: string): boolean;
   var pu: Tstringlist;
begin
  result := false;
  if EXE_ETC_Datei(pfad) then exit;
  try
    application.ProcessMessages;
    Form11_suchen.Lpfad.caption := pfad;
    if abbruchknopfgedrueckt(pfad) then exit;
    pu := Tstringlist.Create;
    try
      pu.LoadFromFile(pfad);
      if Str1IstInStr2(s,pu.text) then result := true;
    finally pu.free End;
  except Form11_suchen.ListBox1.Items.Add(pfad + ' | konnte nicht durchsucht werden') End;
end;

procedure ZuListbox1FallsKiterienerfuellt(const pfad: string; const size: integer;
          zeit: TDateTime; attr: integer;
          const Und: boolean; const a,b,c,d,e,f, nicht: string);
  var drin: boolean;
begin
  with Form11_suchen do Begin
    if und then BEgin //"und"
      drin := true;
      if (a > '') and not Str1IstInStr2(a,pfad) then drin := false;
      if (b > '') and not Str1IstInStr2(b,pfad) then drin := false;
      if (c > '') and not Str1IstInStr2(c,pfad) then drin := false;
      if d > '' then if not istInderDatei(d,pfad) then drin := false;
      if e > '' then if not istInderDatei(e,pfad) then drin := false;
      if f > '' then if not istInderDatei(f,pfad) then drin := false;
    End else Begin //"oder"
      drin := false;
      if (a = '') and (d = '') then drin := true;
      if (a > '') and Str1IstInStr2(a,pfad) then drin := true;
      if (b > '') and Str1IstInStr2(b,pfad) then drin := true;
      if (c > '') and Str1IstInStr2(c,pfad) then drin := true;
      if d > '' then if istInderDatei(d,pfad) then drin := true;
      if e > '' then if istInderDatei(e,pfad) then drin := true;
      if f > '' then if istInderDatei(f,pfad) then drin := true;
    End;
    if (nicht > '') and Str1IstInStr2(nicht,pfad) then drin := false;
    if drin then Begin
      InListboxEinfuegen(60,ListBox1,pfad,size,zeit,attr);
      inc(AnzahlDateien);
      AnzahlBytes := AnzahlBytes + size;
      if anzahlDateien mod 1000 = 0 then application.ProcessMessages;
      Lanzahl.caption := Formatfloat('### ###',AnzahlDateien);
      LBytes.caption := Formatfloat('### ### ###', Anzahlbytes)
    End;
  End;
end;

procedure VerzeichnisDurchsuchen(dir: string;
                const Und: boolean; const a,b,c,d,e,f, nicht: string);
                //a,b,c im Dateinamen; d,e,f in Datei
     var SR: TSearchRec;
         dirtemp : string;
Begin
    Form11_suchen.LPfad.Caption := dir;
    application.ProcessMessages;
    dir := IncludeTrailingBackslash(dir);
    VorUndNachabbruchknopfgedrueckt;
    if FindFirst(dir+'*.*',faAnyFile,SR)=0 then Begin
    repeat
      if abbruchknopfgedrueckt(dir) then exit;
      //Eintrag ist eine Datei
      If ((sr.attr And faDirectory) = 0) and (SR.Name[1]<>'.') then
        ZuListbox1FallsKiterienerfuellt(dir + sr.name, sr.size,
          FileDateToDateTime(sr.Time),sr.Attr,
          Und,a,b,c,d,e,f,nicht);
      //Eintrag ist ein Verzeichnis
      if (SR.Attr and faDirectory = faDirectory)
        and (SR.Name[1] <> '.') and (Form11_suchen.CheckBox1.Checked) then Begin
            dirTemp := dir + sr.name;
            VerzeichnisDurchsuchen(dirtemp, Und,a,b,c,d,e,f,nicht);  //Rekursiv
        End;
    until FindNext(SR)<>0;
    VorUndNachabbruchknopfgedrueckt;
    FindClose(SR);
  End;
End;

procedure TForm11_suchen.Button1Click(Sender: TObject);
     var dir : string;
         UndOder: boolean;
begin
  try
    AnzahlDateien := 0;
    AnzahlBytes := 0;
    VorUndNachabbruchknopfgedrueckt;
    if B_und_Oder.Caption = 'Oder' then UndOder := false else
      undOder := true;
    dir := edit7.text;
    if nurspaces(dir) then Begin
      ok('Ordner, zum Beispiel "C:\Win" eingeben!');
      exit;
    End;
    Listbox1.Items.Clear;
    VerzeichnisDurchsuchen(dir, UndOder, edit1.text, edit2.text, edit3.text,
                                edit4.text, edit5.text, edit6.text,
                                edit8.text);
  finally
    WAVDauerEinmalig := 1/20;
    spieleTon(880);
    VorUndNachabbruchknopfgedrueckt;
    LPfad.Caption := '';
    if edit4.text > '' then gsuchtext := edit4.Text;
    //Jetzt kann man Datei aufrufen und gsuchtext in Datei genau suchen
  End;
end;

procedure TForm11_suchen.B_und_OderClick(Sender: TObject);
begin
  if B_und_Oder.Caption = 'Oder' then B_und_Oder.caption := 'Und'
    else B_und_Oder.caption := 'Oder'
end;

procedure TForm11_suchen.Button4Click(Sender: TObject); //Editfelder lschen
var k: integer;
   a: Tcomponent;
begin
  for k := 0 to ComponentCount - 1 do Begin
    a := components[k];
    if a.ClassType = TEdit then if a <> edit7 then (a as Tedit).text := '';
  End;
   Listbox1.Items.Clear;
   Lanzahl.caption := '';
   LBytes.caption := '';
end;


procedure TForm11_suchen.ListBox1DblClick(Sender: TObject); //Datei ffnen
  var pfad: string;
  procedure start;
    begin
     gProgrammEtcStarten := lowercase(extractfileext(pfad));
     chdir(pfad); //Pfad muss gewechselt werden
     if  ShellExecute(application.handle,
         Pchar('open'),
         Pchar(extractFilename(Pfad)),
         Pchar(gParameter),
         Pchar(extractFilepath(pfad)),
         sw_ShowNormal) < 32 then
           okfehler('Nicht gestartet');
    end;
begin
  With listbox1 do Begin
    if itemindex < 0 then exit;
    pfad := dateinahmeOhneZusatz(Items[ItemIndex]);
    if exe_Etc_Datei(pfad) then Begin
      if gProgrammEtcStarten = lowercase(extractfileext(pfad)) then start
      else if frage('Programm (dazu) "' + pfad + '" starten?'#13+
                '(Rckfrage einmal pro Sitzung)') then start;
      exit;
    End;
    OffneDatei(pfad);
    formstyle := fsstayontop;
  End;
end;

procedure TForm11_suchen.Button5Click(Sender: TObject); //Dateien mit Ordner kopieren
  var k: integer;
      von, nach: Tstringlist;
      neudir: string;
begin
  if listbox1.items.Count = 0 then Begin
    ok('Zuerst "Start Suche klicken" (Alle Dateien: Felder Suchkriterien leer.)');
    exit;
  End;
  if listbox1.SelCount = 0 then Begin
    for k := 0 to listbox1.Items.Count - 1 do
      listbox1.Selected[k] := true;
      ok('Keine waren markiert. Alle wurden markiert. Klicken Sie nochmal!'#13+
         '(Oder whlen Sie zunchst die zu Lschenden aus.)' );
    exit;
  End;
  neudir := '';
  //if not SelectDirectory('Laufwerk und evtl. Ordner auswhlen (neu anlegen). '#13 +
  //                   'Dann:"OK" anklicken.', '', neudir) then exit;
  if not SelectDirectory(NeuDir, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then exit;
  neudir := IncludeTrailingBackslash(neudir);
  von := Tstringlist.Create;
  nach := Tstringlist.Create;
  try
    for k := 0 to listbox1.Items.Count - 1 do
      if listbox1.Selected[k] then Begin
        von.Add(dateinahmeOhneZusatz(listbox1.items[k]));
        nach.add(neudir+copyab(dateinahmeOhneZusatz(listbox1.items[k]),4));
      End;
      if not MeldungsfensterOk('Datein kopieren','Daten werden kopiert'#13+
                               '          nach',
                               nach.text + #13+
                               '         von'#13#13+
                                von.text)
      then exit;
      VorUndNachabbruchknopfgedrueckt;
      for k := 0 to von.Count - 1 do Begin
        DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(von[k], nach[k]);
        application.ProcessMessages;
        Form14abbrechen.show;
        form14abbrechen.Labbrechen.caption := '"' + von[k] + '" wird kopiert nach "' + nach[k];
        if abbruchknopfgedrueckt(von[k] + '->' + nach[k]) then exit;
      End;
  finally
    VorUndNachabbruchknopfgedrueckt;
    LPfad.Caption := '';
    von.free; nach.free
  End;
end;

procedure TForm11_suchen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  formstyle := fsnormal;
end;

procedure TForm11_suchen.ImmerimVordergrund1Click(Sender: TObject);
begin
  formstyle := fsstayonTop;
end;

procedure TForm11_suchen.zurck1Click(Sender: TObject);
begin
  close
end;

procedure TForm11_suchen.Allesauswahlen1Click(Sender: TObject);
  var K: integer;
begin
   for k := 0 to listbox1.Items.Count - 1 do
    listbox1.Selected[k] := true;
end;

procedure TForm11_suchen.IndenTTTextpapierkorbverschieben1Click(
  Sender: TObject);
begin
   indenPapierkorbverschieben(listbox1,'');
   Button1Click(Nil);
end;

procedure TForm11_suchen.Endgltiglschen1Click(Sender: TObject);
begin
   DateienEndgueltigloeschen(listbox1,'');
   Button1Click(nil);
end;

end.
