unit Unit16vergleich;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

type
  TForm16vergleich = class(TForm)
    Panel1: TPanel;
    REaktuell: TRichEdit;
    Splitter1: TSplitter;
    REgleich: TRichEdit;
    Splitter2: TSplitter;
    REvergleich: TRichEdit;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Eaktuell: TEdit;
    Label4: TLabel;
    Evergleich: TEdit;
    Egleich: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure REaktuellMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form16vergleich: TForm16vergleich;
  NochNichtMitNummernversehen: boolean;

procedure Dateienvergleichen;

implementation
uses Unit_ttText_hilf, Unit_ttText_wav, unit1;

{$R *.DFM}

function inttostr4(const k:integer): string;
begin
  result := inttostr(k+1);
  while length(result) < 4 do result := ' ' + result;
end;

procedure nummeriere(e: TRichedit);
  var k: integer;
begin
  for k := 0 to e.lines.Count - 1 do
    e.Lines[k] := inttostr4(k) + '|' + e.lines[k]
end;

procedure Dateienvergleichen;
    var k, zaehl, max: integer;
  procedure gleich;
  begin
     form16vergleich.REgleich.lines.Add('=');
  end;
  procedure ungleich(const k:integer);
    begin
      form16vergleich.REgleich.lines.Add(inttostr(k+1));
      inc(zaehl);
    end;
begin
  with form16vergleich do Begin
    eaktuell.text := '';
    egleich.text := '';
    evergleich.text := '';
    max := REaktuell.lines.count;
    if REvergleich.lines.count < max then max := REvergleich.lines.count;
    while REaktuell.Lines.Count < max do REaktuell.Lines.Add('');
    while REvergleich.Lines.Count < max do REvergleich.Lines.Add('');
    if NochNichtMitNummernversehen then Begin
      nummeriere(reaktuell);
      nummeriere(revergleich);
      NochNichtMitNummernversehen := false;
    End;
    //Gre anpassen
    regleich.lines.Clear;
    REaktuell.PlainText := true;
    REvergleich.PlainText := true;
    REgleich.PlainText := true;
    REaktuell.Font.size := editor[eNr].font.size;
    REvergleich.Font.size := editor[eNr].font.size;
    REgleich.Font.size := editor[eNr].font.size;
    //Jetzt wird verglichen
    zaehl := 0;
    for k := 0 to max - 1 do
      if trimright(reaktuell.lines[k]) <> trimright(revergleich.lines[k]) then
        ungleich(k) else gleich;
  edit2.Text := IntToStr(zaehl);
  edit1.text := IntToStr(reaktuell.lines.count - zaehl);
  edit2.font.Color := clyellow;
  if zaehl = 0 then edit2.Color := clwhite else edit2.color := clred;
  End;
end;

procedure TForm16vergleich.FormCreate(Sender: TObject);
begin
  windowstate := wsmaximized;
end;

procedure TForm16vergleich.Button2Click(Sender: TObject);
begin
  tontief;
  close;
end;

procedure TForm16vergleich.Button1Click(Sender: TObject);
begin
  Dateienvergleichen;
end;

procedure TForm16vergleich.REaktuellMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   var k: integer;
       s: string;
begin
  ton;
  k := ZeiledesCursors(REaktuell);
  eaktuell.text := reaktuell.lines[k];
  evergleich.text := revergleich.lines[k];
  while length(eaktuell.text) < length(evergleich.text) do eaktuell.text := eaktuell.text + ' ';
  setlength(s, length(eaktuell.text));
  for k := 1 to length(eaktuell.text) do
    if char_0(eaktuell.text,k) = char_0(evergleich.text,k) then
      s[k] := '_' else s[k] := '#';
  egleich.Text := s;
end;

end.
