{$I DebuggerAnAus.pas}
unit Unit6einstellungen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileCtrl, shellapi, Spin, ComCtrls;

type
  TForm6 = class(TForm)
    Panel1: TPanel;
    CBSicherungskopie: TCheckBox;
    EPapierkorb: TEdit;
    LImOrdner: TLabel;
    BPapierkorbsuchen: TButton;
    Panel2: TPanel;
    BSchliessen: TButton;
    Panel3: TPanel;
    CBPartition: TCheckBox;
    EPartition: TEdit;
    BPartitionsuchen: TButton;
    BPapierkorboeffnen: TButton;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    SeTondauer: TSpinEdit;
    Label3: TLabel;
    TrackBar1: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Panel5: TPanel;
    Button4: TButton;
    FontDialog1: TFontDialog;
    Button5: TButton;
    Panel6: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    SEoben: TSpinEdit;
    SElinks: TSpinEdit;
    SErechts: TSpinEdit;
    Lmeldung: TLabel;
    Panel7: TPanel;
    Label12: TLabel;
    Label10: TLabel;
    SELeerstellen: TSpinEdit;
    Label11: TLabel;
    SELeerzeilen: TSpinEdit;
    Button6: TButton;
    RadioGroup1: TRadioGroup;
    procedure BSchliessenClick(Sender: TObject);
    procedure CBSicherungskopieClick(Sender: TObject);
    procedure BPapierkorbsuchenClick(Sender: TObject);
    procedure BPartitionsuchenClick(Sender: TObject);
    procedure CBPartitionClick(Sender: TObject);
    procedure BPapierkorboeffnenClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SEobenChange(Sender: TObject);
    procedure SElinksChange(Sender: TObject);
    procedure SErechtsChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const SectionEinstellungen ='Einstellungen';
      SchluesselPapierkorbJaNein = 'TaeglichSicherungskopie';
      SchluesselPartitionJaNein = 'SicherungAuZweitesTraeger';
      SchluesselOrdnerPapierkorb = 'OrdnerFuerSicherungskopieTaeglich';
      SchluesselOrdnerPartition = 'OrdnerfuerSicherungZweiterTraeger';
      SchluesselTondauer ='Tondauer';
      SchluesselTonstaerke ='Tonstaerke';
      schluesselSchiftname = 'Schrift';
      schluesselSchiftgroesse = 'Schriftgroesse';
      schluesselSchriftartfett = 'fett';
      schluesselRandoben = 'Rand oben';
      schluesselRandLinks = 'Rand links';
      schluesselRandRechts ='Rand rechts';
      schluesselLeerstellen = 'Leerstellen';
      schluesselLeerzeilen = 'Leerzeilen';
      schluesselNumlock = 'Numlock';


var
  Form6: TForm6;
  EinstellungenZeigenDasErsteMal: boolean = true;


procedure Form6showmodal;
procedure Form6shomodalDasErsteMal(meldung: string);


implementation

uses ComObj,
     Unit10explorer, Unit_ttText_hilf, Unit_ttText_ini, Unit_ttText_wav,
     Unit1, Unit8memo, Unit3webtxt;

{$R *.DFM}

function bitgesetzt(c: cardinal; stellen: integer): boolean;
begin
  if (c shr stellen) mod 2 = 1 then result := true else result := false;
end;



function hoechstesLaufwerk: char;
  var c: dword;
      d: char;
begin
  c := GetLogicalDrives;
  for d := 'z' downto 'a' do
  if bitgesetzt(c, ord(d) - 97) then Begin
    result := d;
    exit;
  End;
  result := 'z'; //wg Compiler
end;

procedure Form6showmodal0;
begin
  with Form6 do Begin
    if LeseIni(SectionEinstellungen,SchluesselTondauer) > '' then
    try
      SeTondauer.Value := StrToInt(LeseIni(SectionEinstellungen,SchluesselTondauer));
    except SeTondauer.Value := 0 End else  SeTondauer.Value := 100;
    if LeseIni(SectionEinstellungen,SchluesselTonstaerke) > '' then
    try
      trackbar1.Position := StrToInt(LeseIni(SectionEinstellungen,SchluesselTonstaerke));
    except trackbar1.Position := 100 End else  trackbar1.Position := 100;

    EPapierkorb.Text := LeseIni(SectionEinstellungen,SchluesselOrdnerPapierkorb);
    if EPapierkorb.Text = '' then
      EPapierkorb.text := extractFilepath(paramstr(0));
    EPartition.Text := LeseIni(SectionEinstellungen,SchluesselOrdnerPartition);
    if EPartition.text = '' then EPartition.Text := hoechstesLaufwerk + ':\';
    if LeseIni(SectionEinstellungen,SchluesselPapierkorbJaNein) = 'Nein' then
      CBSicherungskopie.Checked := false          //wird gleich true
        else  CBSicherungskopie.Checked := true;  //wird gleich false
    CBSicherungskopieClick(Nil);
    if LeseIni(SectionEinstellungen,SchluesselPartitionJaNein) <> 'Ja' then
      CBPartition.Checked := false          //wird gleich true
        else  CBPartition.Checked := true;  //wird gleich false
    CBPartitionClick(Nil);
    try
      SEoben.value := strToInt(leseIni(SectionEinstellungen,schluesselRandoben))
    except SEoben.value := 20 ENd;
    try
      SElinks.value := strToInt(leseIni(SectionEinstellungen,schluesselRandlinks))
    except SElinks.value := 20 ENd;
    try
      SErechts.value := strToInt(leseIni(SectionEinstellungen,schluesselRandrechts))
    except SErechts.value := 0 ENd;
    try
      SELeerstellen.value := strToInt(leseIni(SectionEinstellungen,schluesselLeerstellen))
    except SELeerstellen.value := 5 ENd;
    try
      SELeerzeilen.value := strToInt(leseIni(SectionEinstellungen,schluesselLeerzeilen))
    except SELeerzeilen.value := 2 ENd;
    try
      Radiogroup1.itemindex := StrToInt(LeseIni(SectionEinstellungen, Schluesselnumlock));
    except End;
  // Das Wichtigste
  showmodal;
  End;
end;

procedure Form6showmodal;
begin
  form6.lmeldung.caption := '';
  Form6showmodal0;
end;



procedure Form6shomodalDasErsteMal(meldung: string);
begin
  if EinstellungenZeigenDasErsteMal then Begin
    form6.Lmeldung.Caption := meldung;
    Form6showmodal0;
    EinstellungenZeigenDasErsteMal := false;
  End;
end;


procedure TForm6.BSchliessenClick(Sender: TObject);
begin
  SchreibeIni(SectionEinstellungen,SchluesselTondauer,IntToStr(seTondauer.value));
  SchreibeIni(SectionEinstellungen,SchluesselTonstaerke,IntToStr(trackbar1.position));
  SchreibeIni(SectionEinstellungen,SchluesselOrdnerPapierkorb,EPapierkorb.Text);
  if CBSicherungskopie.checked then
    schreibeIni(SectionEinstellungen,SchluesselPapierkorbJaNein,'Ja') else
         schreibeIni(SectionEinstellungen,SchluesselPapierkorbJaNein,'Nein');

  SchreibeIni(SectionEinstellungen,SchluesselOrdnerPartition,EPartition.Text);
  if CBPartition.Checked then
    SchreibeIni(SectionEinstellungen,SchluesselPartitionJaNein,'Ja') else
      SchreibeIni(SectionEinstellungen,SchluesselPartitionJaNein,'Nein');
  schreibeIni(SectionEinstellungen,schluesselRandoben,inttostr(SEoben.value));
  schreibeIni(SectionEinstellungen,schluesselRandlinks,inttostr(SElinks.value));
  schreibeIni(SectionEinstellungen,schluesselRandrechts,inttostr(SErechts.value));
  schreibeIni(SectionEinstellungen,schluesselleerstellen,inttostr(SELeerstellen.value));
  schreibeIni(SectionEinstellungen,schluesselleerzeilen,inttostr(SELeerzeilen.value));
  //Das Wichtigste
  close;
end;

procedure TForm6.CBSicherungskopieClick(Sender: TObject);
begin
  if CBSicherungskopie.checked then BEgin
      Epapierkorb.visible := true;
      BPapierkorbsuchen.visible := true;
      LImOrdner.Visible := true;
      Label4.show;
    ENd else BEgin
      Epapierkorb.visible  := false;
      BPapierkorbsuchen.visible := false;
      LImOrdner.Visible := false;
      label4.Hide;
    ENd;
end;

procedure TForm6.BPapierkorbsuchenClick(Sender: TObject);
var dir: string;
begin
  dir := LeseIni(SectionEinstellungen,SchluesselOrdnerPapierkorb);
  try
  if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],0) 
    then EPapierkorb.text := dir;
  except ok('Auf das Verzeichnis kann zur Zeit nicht zugegriffen werden!'); End;
end;

procedure TForm6.BPartitionsuchenClick(Sender: TObject);
  var dir: string;
begin
 try
    if SelectDirectory('Laufwerk auswhlen.'#13 +
       'Dann:"OK" anklicken.','', dir)
      then EPartition.text := dir;
  except ok('Auf das Verzeichnis kann zur Zeit nicht zugegriffen werden!'); End;
end;

procedure TForm6.CBPartitionClick(Sender: TObject);
begin
    if CBPartition.checked then BEgin
      Epartition.visible := true;
      BPartitionsuchen.visible := true;
    ENd else BEgin
      Epartition.visible := false;
      BPartitionsuchen.visible := false;
    ENd;
end;

procedure TForm6.BPapierkorboeffnenClick(Sender: TObject);
  var pfad: string;

begin
  pfad :=  LeseIni(SectionEinstellungen,SchluesselOrdnerPapierkorb)+'\papierkorb';
  with form10explorer1.DirectoryListBox1 do
    try
      Directory := pfad
    except Directory := copy(pfad,1,3) End;
  form10explorer1.Show;
  form10explorer1.zeigeDateien(pfad);
  close; 
end;

procedure TForm6.TrackBar1Change(Sender: TObject);
begin
   SchreibeIni(SectionEinstellungen,SchluesselTonstaerke,IntToStr(trackbar1.position));
   ton;
end;

procedure TForm6.Button2Click(Sender: TObject);
begin
  spiele(275,330,440,550,0,0,0,0);
end;

procedure TForm6.Button3Click(Sender: TObject);
begin
   spiele(330,440,550,660,0,0,0,0);
end;

procedure TForm6.Button1Click(Sender: TObject);
begin
   spiele(440,550,660,880,0,0,0,0);
end;

procedure TForm6.Button4Click(Sender: TObject);
  var k: integer;
begin
  with fontdialog1 do Begin
    font.name := form3.RichEdit1.Font.Name;
    font.size := form3.RichEdit1.Font.Size;
    font.style := form3.RichEdit1.Font.Style;
    if execute then BEgin
      SchreibeIni(SectionEinstellungen, schluesselSchiftname, font.name);
      SchreibeIni(SectionEinstellungen, schluesselSchiftgroesse, intToStr(font.size));
      if font.style = [fsbold] then
        SchreibeIni(SectionEinstellungen, schluesselSchriftartfett, schluesselSchriftartfett) else
           SchreibeIni(SectionEinstellungen, schluesselSchriftartfett, 'nicht fett');
    ENd
  End;
  schriftsetzten(form3.Richedit1);
  for k := 0 to length(editor) - 1 do
    schriftsetzten(editor[k]);
end;

procedure TForm6.Button5Click(Sender: TObject);
  var k: integer;
begin
  SchreibeIni(SectionEinstellungen, schluesselSchiftname, 'Courier New');
  SchreibeIni(SectionEinstellungen, schluesselSchiftgroesse, '10');
  SchreibeIni(SectionEinstellungen, schluesselSchriftartfett, 'nicht fett');
  schriftsetzten(form3.Richedit1);
  for k := 0 to length(editor) - 1 do
    schriftsetzten(editor[k]);
end;

procedure TForm6.SEobenChange(Sender: TObject);
begin
  schreibeIni(SectionEinstellungen,schluesselRandoben,intToStr(SEoben.value));
end;

procedure TForm6.SElinksChange(Sender: TObject);
begin
  schreibeIni(SectionEinstellungen,schluesselRandlinks,intToStr(SElinks.value));
end;

procedure TForm6.SErechtsChange(Sender: TObject);
begin
  schreibeIni(SectionEinstellungen,schluesselRandrechts,intToStr(SErechts.value));
end;

procedure TForm6.Button6Click(Sender: TObject);
  var e:OleVariant;
Begin
  ok('Im MS-Explorer werden die Rnder ber "Datei|Seitenansicht" eingestellt. '+
     'Die Einstellungen hier werden noch dazu addiert. '+
     'Die genderten Einstellungen des MS-Explorers werden nach einem Neustart '+
     'von TTText wirksam.');
  try e:=CreateOleObject('InternetExplorer.Application'); //uses ComObj
  Except ok('Internetexplorer nicht installiert'); exit; End;
  try
    e.visible:=true;
    e.top:=25;
    e.Navigate('about:blank');
  except ok('Ms-Explorer streikt!'); End;
end;

procedure SetzeKeybordStatus(Key: byte; an:boolean);
  var  KeyState: TKeyboardState;
begin
  GetKeyBoardState(KeyState);
  if an then KeyState[Key] := 1
    else KeyState[key] := 0;
  SetKeyboardState(KeyState);
end;

procedure TForm6.RadioGroup1Click(Sender: TObject);
begin
   Case Radiogroup1.itemindex of 0: SetzeKeybordStatus(vk_numlock,true);
                                 1: SetzeKeybordStatus(vk_numlock,false);
   End;
   schreibeIni(SectionEinstellungen, Schluesselnumlock, intToStr( Radiogroup1.itemindex));
end;

end.
