{$I DebuggerAnAus.pas}
unit Unit_ttText_hilf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ExtCtrls, FileCtrl;

const spaces40 = '                                        ';
      spaces80 = spaces40 + spaces40;
      gpapierkorb = 'papierkorb';

var
 gSucheFarbe: Tcolor = clmaroon;
 gSuchtext: string = '';
 gErsetzteText: string = '';
 gparameter: string = '';
 Dateienimmerueberschreiben: boolean = false;
 HinweisVoruebergehendgesp: boolean = true;
function OhneEt(const s:string): string;
function DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(von, nach: string): string; //result>'' bedeutet Fehler
procedure ok(const s: string);
function frage(const s: string): boolean;
procedure okfehler(const s: string);
function Str1IstInStr2(const a,b: string): boolean;
Procedure KopiereDateiIndenPapierkorb(pfad: String);
function GetLongPathName(APath:String):String;
procedure ErmittleZeileUndSpalte(e: Trichedit; var Zeile, Spalte: integer);
function wort_(s: string; k: integer): string;
procedure bubblesort(var pu: TStringlist);
function eingabeInteger(Titel, Promt: string; var n: integer): boolean;
procedure zeichneLinie(e: TRichedit);
procedure setCursor(E: Trichedit; zeile, spalte: integer);
function ohneEndLeerzeichen(const s: string): string;
procedure entferneLeerzeichenUndLeerZeilen(e: TRichedit);
procedure entferneLeerzeichenUndLeerZeilenUndSpeichereAb(e: TRichedit; pfad: string);
function Durchsuche(e: TRichedit; mitAnfrage: boolean): boolean;
function Ersetzte(e: TRichedit; mitAnfrage: boolean): boolean;
function char_0(const s: string; const k: integer): char;
function min(const a,b: integer): integer;
function copyab(const s: string; const i: integer): string;
function StrToIntTolerant(const s: string): integer;
procedure prs(const s: string); overload;
procedure prs(const x: extended); overload;
procedure prs(const b: boolean); overload;
function nurspaces(const s: string): boolean;
procedure Zeilenumbrechen(var s: string; laenge: integer; Zeilenausgleich: boolean);
Procedure zuHistory(const pfad: string);
Procedure zuHistoryMitPruefen(const pfad: string);
function exe_Etc_Datei(pfad: string): boolean;
procedure schriftsetzten(e: Trichedit);
function TmpHtml: string;
function TmpHtmlImOrdner: string;
function gpfad_Enr:string; //=pfad[eNr] oder tmphtml
function abbruchknopfgedrueckt(const s: string): boolean; //vorher und nachher  Abbruchknopfhide
procedure VorUndNachabbruchknopfgedrueckt;
function InListboxEinfuegen(platzfuerDateiname: integer; lb: Tlistbox; name:string; size:integer;
           zeit: TDateTime; attribut: integer):string;
procedure StrgH_Sonderzeichen(ed: TRichedit);
function MitLeerstellenaufgefuellt(const satz: string): string;
function MainMenuitemindex(m: Tmainmenu; const s: string): integer;
function plusspaces(const s: string; const n: integer): string;
procedure SetzeKeybordStatus(Key: byte; an:boolean);

implementation


uses unit1, unit2h, unit3webtxt, unit6einstellungen, Unit_ttText_ini, unit12meldung,
     Unit10explorer, unit14abbrechen,
     Unit_ttText_html, Unit_ttText_wav;

procedure SetzeKeybordStatus(Key: byte; an:boolean);
  var  KeyState: TKeyboardState;
begin
  GetKeyBoardState(KeyState);
  if an then KeyState[Key] := 1
    else KeyState[key] := 0;
  SetKeyboardState(KeyState);
end;

function plusspaces(const s: string; const n: integer): string;
begin
  result := s + copy(spaces80,1,n - length(s));
end;


function MainMenuitemindex(m: Tmainmenu; const s: string): integer; //s mu Hauptmenu sein!
  var k: integer;
begin
  with m do Begin
    k := 0;
    while (k < items.count) and (ohneEt(items[k].Caption) <> s) do inc(k); 
    result := k;
  End;
end;

function MitLeerstellenaufgefuellt(const satz: string): string;
  var pu: Tstringlist;
       k: integer;
begin
  pu := Tstringlist.create;
  try
    pu.text := satz;
    for k := pu.Count - 1 downto 0 do
      if length(pu[k]) < 80 then
        pu[k] := pu[k] + copy(spaces80,1,80 - length(pu[k]));
    result := pu.text;
  finally pu.free End;
end;

procedure StrgH_Sonderzeichen(ed: TRichedit);
  var altselstart: integer;
begin
  altselstart := ed.selstart;
  if form2.Visible then form2.Close;
   with Form2.stringgrid1 do Begin
    ColWidths[0] := 30;
    ColWidths[1] := 60;
    ColWidths[2] := 110;
    width := 210;
    form2.ClientWidth := 210;
   End;
  form2.left := screen.Width - 220;
  form2.showmodal;
  if Form2Rueckabe <> #27 then Begin
    ed.seltext := Form2Rueckabe;
    if pos('>',Form2Rueckabe) > 0 then
      ed.SelStart := altselstart + pos('>',Form2Rueckabe);
  End;
end;

function attr_(at: integer): string;
begin
  result := '';
  if at < 0 then exit;
  if at and 1 = 1 then result := result + 'R'; //Read-Only
  if at and 2 = 2 then result := result + 'H'; //Hidden
  if at and 4 = 4 then result := result + 'S'; //System-Dateien
  if at and 8 = 8 then result := result + 'D'; //Laufwerke
         //if at and  16 = 16 then result:=result+'O:';
  if at and 64 = 64 then result := result + 'X'; //knftige Erweiterungen
  if at and 128 = 128 then result := result + 'Y';
  if not (at and 32 = 32) then if not (at and 16 = 16) then result := result + '_';
end;

function InListboxEinfuegen(platzfuerDateiname: integer; lb: Tlistbox; name:string; size:integer;
           zeit: TDateTime; attribut: integer):string;
  function mind(const s:string; const n: integer): string;
  begin
    result := s + copy(spaces40,1,n - length(s));
  end;
Begin
  if pos('.html', lowercase(name)) > 0  then name := ' ' + name;
  lb.Items.Add(mind(name,platzfuerDateiname) + '|' +  attr_(attribut) +
    mind(formatfloat('### ### ##0',size),10) + '|'+
      FormatDateTime('dd.mm.yy ddd hh:mm',zeit));
end;


function abbruchknopfgedrueckt(const s: string): boolean; //vorher  und nachher Abbruchknopfhide
begin
  application.ProcessMessages;
  Form14abbrechen.show;
  form14abbrechen.Labbrechen.caption := s;
  if form14abbrechen.Width < form14abbrechen.Labbrechen.width then
    form14abbrechen.Width := form14abbrechen.Labbrechen.width + 50;
  result := Abbruchausgeloest;
end;

procedure VorUndNachabbruchknopfgedrueckt;
begin
  Abbruchausgeloest := false;
  form14abbrechen.Hide;
end;



function TmpHtml: string;
begin
  result := lowercase(extractfiledir(paramstr(0)) + '\tmp.html');
end;

function TmpHtmlImOrdner: string;
begin
  if form1.tabcontrol1.Tabs.Count = 0 then result := TmpHtml else
  if pos(neuIstLeer,gpfad[Enr]) = 1 then  result := TmpHtml else
    result := lowercase(extractfiledir(gpfad[enr]) + '\tmp.html');
end;

function gpfad_Enr:string; //=pfad[eNr] oder tmphtml
begin
   if Form1.tabcontrol1.Tabs.Count = 0 then neuenEditor;
   if pos(neuIstLeer,gpfad[Enr]) = 1 then Begin
     result := tmphtml;
     if HinweisVoruebergehendgesp then BEgin
       ok('Vorbergehend gespeichert unter:' + result + #13#13+
          'Dieser Hinweis erscheint, da die Datei noch nicht endgltig abgespeichert wurde.'#13+
          '(Er erscheint nur einmal pro Sitzung.)');
       HinweisVoruebergehendgesp := false;
     ENd;
   End else result := gpfad[Enr];
end;


procedure schriftsetzten(e: Trichedit);
  var nam, siz, sty: string;
      si: integer;
begin
   nam := LeseIni(SectionEinstellungen, schluesselSchiftname);
   if nam = '' then nam := form3.RichEdit1.Font.Name;
   siz := LeseIni(SectionEinstellungen, schluesselSchiftgroesse);
   if siz = '' then siz := intToStr(form3.RichEdit1.Font.size);
   sty := LeseIni(SectionEinstellungen, schluesselSchriftartfett);
   try
     si := strToInt(siz);
     if (si < 4) or (si > 72) then si := 10;
   except si := 10 End;
   e.Font.Name := nam;
   e.Font.Size := si;               
   if sty = schluesselSchriftartfett then e.Font.Style := [fsbold] else e.font.Style := [];
end;


function OhneEt(const s:string): string;
  var k:integer;
begin
  result := '';
  for k := 1 to length(s) do if s[k] <> '&' then result := result + s[k];
end;


procedure ok(const s: string);
begin
  MessageDlg(s,mtInformation, [mbOK] ,0);
end;

procedure okfehler(const s: string);
begin
  tonhoch;
  MessageDlg(s,mtError, [mbOK] ,0);
end;

function frage(const s: string): boolean;
begin
  result := MessageDlg(s, mtConfirmation, [mbYes, mbNo],0) = 6; //Ja
end;

function Str1IstInStr2(const a,b: string): boolean;
begin
  result := pos(AnsiLowercase(a),AnsiLowercase(b)) > 0;
end;



function GetLongPathName(APath:String):String;
var
  i : Integer;
  h : THandle;
  Data : TWin32FindData;
  IsBackSlash : Boolean;
begin
  APath:=ExpandFileName(APath);
  i:=Pos('\',APath);
  Result:=Copy(APath,1,i);
  Delete(APath,1,i);
  repeat
    i:=Pos('\',APath);
    IsBackSlash:=i>0;
    if Not IsBackSlash then
      i:=Length(APath)+1;
    h:=FindFirstFile(PChar(Result+Copy(APath,1,i-1)),Data);
    if h<>INVALID_HANDLE_VALUE then begin
      try
        Result:=Result+Data.cFileName;
        if IsBackSlash then
          Result:=Result+'\';
      finally
        Windows.FindClose(h);
      end;
    end
    else begin
      Result:=Result+APath;
      Exit;
    end;
    Delete(APath,1,i);
  until Length(APath)=0;
end; {Peter Haas}




procedure ErmittleZeileUndSpalte(e: Trichedit; var Zeile, Spalte: integer);
begin
  Zeile := SendMessage(e.Handle, EM_LINEFROMCHAR, e.SelStart,0) + 1;
  Spalte := e.SelStart - SendMessage(e.Handle, EM_LINEINDEX, Zeile, 0);
end;

function wort_(s: string; k: integer): string;
var n: integer;
begin
  s := trim(s); //entfernt Leerzeichen, #13 oder andere Steuerzeichen
  n := pos(' ', s);
  if n = 0 then n := pos(#13,s); //Zeilenumbruch
  if n = 0 then Begin
    if k > 1 then result := '' else result := s
  End else Begin //z.B. s='abc def;
    if k > 1 then result := wort_(copyab(s, n + 1), k - 1) //rekursiv
    else result := copy(s, 1, n - 1);
  End;
end;


procedure bubblesort(var pu: TStringlist);
  var i:integer;
      fertig: Boolean;
      x :string;
begin
  repeat
    fertig:=true;
    for i:=0 to pu.Count - 2 do Begin
      if pu[i] > pu[i+1] then BEgin
        x := pu[i];
        pu[i] := pu[i+1];
        pu[i+1] := x;
        fertig:=false;
      ENd;
    End;
  until fertig;
end;



function eingabeInteger(Titel, Promt: string; var n: integer): boolean;
  var stringresult: string;
begin
  stringresult := intToStr(n);
  repeat
    if InputQuery(Titel, promt, stringresult) = false then Begin
      result := false;
      exit;
    End;
    result := true;
    try
      n := strToInt(stringresult);
    except  result := false; okfehler('Bitte nur eine Zahl eingeben'); End;
  until result;
end;

procedure zeichneLinie(e: TRichedit);
  const x = 640;
  var Canvas: TCanvas;
begin
  Canvas := TControlCanvas.Create;
  try
    TControlCanvas(Canvas).Control := e;
    Canvas.Pen.Color := $00E0E0E0; //clsilver;
    Canvas.MoveTo(x,0);
    Canvas.LineTo(x,e.height);
   finally Canvas.Free end;
end;

procedure setCursor(E: Trichedit; zeile, spalte: integer);
var j, z: integer;
begin
  z := 0;
  for J := 0 to min(E.Lines.Count, zeile - 2) do z := z + Length(E.Lines[J]);
  z := z + (zeile - 1) * 2;
  if z + spalte - 2 <= 0 then z := 0 else z := z + spalte - 2;
  E.SelStart := z;
end;

function ohneEndLeerzeichen(const s: string): string;
  var k: integer;
begin
  result := s;
  k := length(s);
  while (k > 0) and (result[k] = ' ') do dec(k);
  setlength(result,k);
end;

procedure entferneLeerzeichenUndLeerZeilen(e: TRichedit);
   var k: integer;
       pu: Tstringlist;
begin
  pu := Tstringlist.Create;
  try
    for k := 0 to e.lines.Count - 1 do
      pu.add(ohneEndLeerzeichen(e.lines[k]));
    while (pu.Count > 0) and (pu[pu.count-1] = '') do
      pu.Delete(pu.Count - 1);
    e.lines.Text := pu.Text;
  finally pu.Free End;
end;

function Papierkorbpfad(pfad: string): string;
    var tag, stamm, OrdnerHeute: string;
  function FileOhneSonderzeichen(const pfad: string): string;
    var k0, k: integer;
        derLetztePunktBleibt: boolean;
  begin
    result := '';
    derLetztePunktBleibt := true;
    k0 := 1; while (length(pfad) - k0) > 50 do inc(k0);
    for k := length(pfad) downto k0 do
      if pfad[k] in ['0'..'9','a'..'z','A'..'Z'] then result := pfad[k] + result
        else if derLetztePunktBleibt then Begin
          if (pfad[k] = '.') then
            result := '.' + result
              else result := '_' + result; //Kein Extender
          derLetztePunktBleibt := false;
        End else result := '_' + result;
  end;
begin
  tag := FormatDateTime('yymmdd', Date);
  stamm :=  LeseIni(SectionEinstellungen,SchluesselOrdnerPapierkorb);
  if stamm = '' then stamm := extractfiledir(paramstr(0));
  stamm := IncludeTrailingBackslash(stamm);
  ordnerheute := stamm + gpapierkorb +'\' + tag + '\';
  result := ordnerheute + FileOhneSonderzeichen(pfad);
end;

function genuegendPlatzaufDiskette(const von, nach: string): boolean;
  var SR: TSearchRec;
begin
  result := true;
  if char_0(lowercase(nach),1) > 'a' then exit;
  try
    if FindFirst(von,faAnyFile,SR) <> 0 then exit; //datei gibts nicht
    if sr.size >  diskfree(1) then Begin
      result := false;
      okfehler('Datei "' + von + '" ist ' + formatfloat('# ###',sr.size) + ' Bytes gro.'#13+
               'Auf Diskette ist jedoch nur noch ' + formatfloat('# ###',diskfree(1)) +
               ' Bytes frei');
    End;
  finally FindClose(SR) end;
end;

function DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(von, nach: string): string; //result > '' bedeutet Fehler
begin
  if von = nach then Begin
    if frage('Datei "' + von + '"kann nicht auf sich selbst kopiert werden'#13+
             'Abbrechen?') then Abbruchausgeloest := true;
    exit;
  End;
  forcedirectories(extractFilepath(nach));
  if fileexists(nach) and not Dateienimmerueberschreiben then Begin
    if lowercase(char_0(LeseIni(SectionEinstellungen,SchluesselOrdnerPartition),1)) <> lowercase(char_0(nach,1)) then
      if frage('Datei "' + nach + '" existiert.'#13+
             'Datei berschreiben?'#13+
             'Achtung:  In dieser Sitzung werden dann knftig alle Dateien berschrieben"') then BEgin
      Dateienimmerueberschreiben := true;
      ENd else BEgin
        result := 'Abbruch';
        exit;
      ENd;
    End;
  if Abbruchknopfgedrueckt('"' + von + '" wird kopiert nach "' + nach) then exit;
  if not genuegendPlatzaufDiskette(von, nach) then
    if frage('Neue Diskette schon eingelegt?'#13+
             'Nein: Datei wird nicht kopiert!') = false then exit;
  if not CopyFile(PChar(von), PChar(nach), false) then //false = existierendes wird berschreiben
  result := '"' + von + '" konnte nicht nach "' + nach + '" kopiert werden:';
end;

Procedure KopiereDateiIndenPapierkorb(pfad: String);
begin
  Abbruchausgeloest := false;
  DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(pfad, Papierkorbpfad(pfad));
end;

Procedure SchreibeAlteDateiInPapierkorb(pfad: String);
begin
  VorUndNachabbruchknopfgedrueckt;
  if LeseIni(SectionEinstellungen,SchluesselPapierkorbJaNein) = 'Nein' then exit;
  if not fileexists(Papierkorbpfad(pfad)) then Begin
    DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(pfad, Papierkorbpfad(pfad));
    spiele(275,330,440,550,0,0,0,0);
  End;
  VorUndNachabbruchknopfgedrueckt;
end;

procedure SicherungkopieAufZweitesLaufwerk(const pfad: string);
  var zweiterPfad: string;
      k: integer;
begin
  if LeseIni(SectionEinstellungen,SchluesselPartitionJaNein) = 'Ja' then Begin
    zweiterPfad := LeseIni(SectionEinstellungen,SchluesselOrdnerPartition);
    if zweiterpfad= '' then BEgin
      Form6showmodal;
      exit;
    ENd;
    if zweiterpfad[1] = pfad[1] then Begin
      okfehler('Datei wird nicht auf zweitem Laufwerk gesichert, '+
               'da beide identisch');
      form6showmodal;
      exit;
    End;
    zweiterpfad := zweiterpfad[1] + copyab(pfad,2);
    for k := 0 to EinmalProSitzung.Count - 1 do
      if zweiterpfad = EinmalProSitzung[k] then exit;
    EinmalProSitzung.Add(zweiterpfad);
    try
      VorUndNachabbruchknopfgedrueckt;
      DateiKopierenMitFileStreamFallsAbbruchnichtausgeloest(pfad, zweiterpfad);
      spiele(330,440,550,660,0,0,0,0);
      VorUndNachabbruchknopfgedrueckt;
    except End;
  End;
end;

Procedure zuHistory(const pfad: string);
  var historypu: Tstringlist;
begin
  historypu := Tstringlist.Create;
  try
    historypu.text := LeseINIStringlist(SectionSchluesselHistory,SectionSchluesselHistory);
    if historypu.Count > 0 then
      if historypu[0] = pfad then exit;
    historypu.Insert(0,pfad);
    if historypu.Count > Maxhistory then historypu.Delete(historypu.count-1);
    SchreibeINIStringlist(SectionSchluesselHistory,SectionSchluesselHistory,historypu.text);
  finally historypu.free End;
end;

Procedure zuHistoryMitPruefen(const pfad: string);
  var makropu, pu: Tstringlist;
     k: integer;
begin
  if pfad = TmpHtmlImOrdner then exit; //(pfad = tmphtml) entfernt
  pu := Tstringlist.create;
  makropu := Tstringlist.Create;
  try
    for k := 1 to MakroAnzahl do Begin
      pu.text := LeseINIStringlist(Makro,IntToStr(k));
      makropu.AddStrings(pu);
    End;
    if pos(pfad,makropu.text) = 0 then zuHistory(pfad);
  finally pu.free; makropu.free End;
end;


procedure entferneLeerzeichenUndLeerZeilenUndSpeichereAb(e: TRichedit; pfad: string);
   var k: integer;
       pu: Tstringlist;
       s: string;
       istHtmlDatei: boolean;
begin //Achtung Text wird HTML-konform abgespeichert. Ist im Editor nicht sichtbar.
  try
    if (pfad <> tmphtml) and (pfad <> TmpHtmlImOrdner)
      and (lowercase(char_0(pfad,1)) <> 'a') then
        SchreibeAlteDateiInPapierkorb(pfad); //Alte Datei sichern!
  except ok('Keine Sicherung im Papierkorb!') End;
  pu := Tstringlist.Create;
  if pos('<html',lowercase(copy(e.text,1, 800))) > 0  //<html in den ersten 10 Zeilen
    then istHtmlDatei := true else istHtmlDatei := false;
  try
    for k := 0 to e.lines.Count - 1 do Begin
      s := e.lines[k];
      if istHtmlDatei then ConvertTTWCharHTML(s);
      pu.add(ohneEndLeerzeichen(s));
    End;
    while (pu.Count > 0) and (pu[pu.count-1] = '') do
      pu.Delete(pu.Count - 1);
    forcedirectories(extractFiledir(pfad));
    pu.SaveToFile(pfad);
    nachricht(pfad + ' (gendert!) gespeichert.');
    if (pfad <> tmphtml) and (pfad <> TmpHtmlImOrdner)
       and (lowercase(char_0(pfad,1)) <> 'a') then
      SicherungkopieAufZweitesLaufwerk(pfad); //Die aktuelle Datei wird gesichert
    spiele(440,550,660,880,0,0,0,0);
    zuHistoryMitPruefen(pfad);
  finally pu.Free End;
end;

function Durchsuche(e: TRichedit; mitAnfrage: boolean): boolean;
var
  FoundAt: LongInt;
  StartPos, ToEnd: Integer;
  alterSuchtext: string;
begin
  result := true;
  if MitAnfrage or (gsuchtext = '') then Begin
     alterSuchtext := gsuchtext;
     gsuchtext := inputbox('Suchen','Geben Sie das Suchwort ein!',gsuchtext);
     if alterSuchtext <> gsuchtext then
     Case gSucheFarbe of clred:   gSucheFarbe := clblue;
                         clblue:  gSucheFarbe := clgreen;
                         clgreen: gSucheFarbe := clnavy;
                         clnavy:  gsucheFarbe := clmaroon;
                         clmaroon: gSucheFarbe := clred;

     End;
  End;
  with e do
  begin
    StartPos := SelStart + SelLength;
    ToEnd := Length(Text) - StartPos;
    FoundAt := FindText(gsuchtext, StartPos, ToEnd, []);
    if FoundAt <> -1 then
    begin
      try SetFocus except End;
      SelStart := FoundAt;
      SelLength := Length(gsuchtext);
      SelAttributes.Color:=gsucheFarbe;
      SelAttributes.Style:=[fsBold];
      selattributes.Size := e.Font.Size + 4;
      SelStart:=SelStart + 1;
    end else  Begin
        result := false;
        Selstart := 0;
        ok('Alles mit "' + gsuchtext + '" durchsucht. Schreibmarke auf den Anfang gesetzt')
    End;
    end;
end;

function Ersetzte(e: TRichedit; mitAnfrage: boolean): boolean;
var
  FoundAt: LongInt;
  StartPos, ToEnd: Integer;
begin
  result := true;
  if MitAnfrage or (gsuchtext = '') then Begin
     gsuchtext := inputbox('Ersetzten','Geben Sie das Suchwort ein!',gsuchtext);
     gErsetzteText := inputbox('Ersetzten','Das Suchwort soll ersetzt werden durch ...',gErsetzteText);
  End;
  with e do
  begin
    StartPos := SelStart + SelLength;
    ToEnd := Length(Text) - StartPos;
    FoundAt := FindText(gsuchtext, StartPos, ToEnd, []);
    if FoundAt <> -1 then
    begin
      try SetFocus except End;
      SelStart := FoundAt;
      SelLength := Length(gsuchtext);
      ClearSelection;
      seltext := gErsetzteText;
      SelStart := FoundAt;
      SelLength := length(gErsetzteText);
      SelAttributes.Color:=clred;
      SelAttributes.Style:=[fsBold];
      selattributes.Size := editor[enr].Font.Size + 4;
      SelStart:=SelStart + length(gErsetzteText);;
    end else  Begin
        result := false;
        Selstart := 0;
        ok('Alles mit "' + gsuchtext + '" durchsucht. Schreibmarke auf den Anfang gesetzt')
    End;
    end;
end;


function char_0(const s: string; const k: integer): char;
begin if (k <= 0) or (k > length(s)) then result := #0 else
    result := s[k]
end;

function min(const a,b: integer): integer;
begin
  if a < b then result := a else result := b;
end;

function copyab(const s: string; const i: integer): string;
begin result := copy(s, i, length(s) - i + 1) end;

function NurZahlen(const s: string): string;
  var k: integer;
begin
 result := '';
 for k := 1 to length(s) do
   if s[k] in ['0'..'9'] then result := result + s[k];
 if result = '' then result := '0';
end;

function StrToIntTolerant(const s: string): integer;
begin
  try
     result := StrToInt(NurZahlen(s));
  except result := 0 End;
end;

procedure prs(const s: string); overload;
begin
  ok(s);
end;

procedure prs(const x: extended); overload;
begin
  ok(FloatToStr(x));
end;

procedure prs(const b: boolean); overload;
begin
  if b then ok('true') else ok('false');
end;

function nurspaces(const s: string): boolean;
  var k: integer;
begin
 result := true;
 for k := 1 to length(s) do
   if s[k] <> ' ' then Begin
     result := false;
     exit;
 End;
end;

procedure Zeilenumbrechen(var s: string; laenge: integer; Zeilenausgleich: boolean);
var n, k, j, halbeLaenge, Ls: integer;
begin
  try
    if Zeilenausgleich then Begin
      s := StringReplace(S, #13, ' ', [rfReplaceAll]);
      s := StringReplace(S, #10, '', [rfReplaceAll]);
    End;
    halbeLaenge := laenge div 2;
    n := 1;
    k := 1;
    ls := length(s);
    while k < Ls do Begin //length(s) ndert sich
      inc(k);
      inc(n);
      if s[k] = #13 then n := 1;
      if n >= laenge then BEgin
        j := 0;
        while (s[k - j] <> ' ') and (k > j) and (j < halbeLaenge) do inc(j);
        k := k - j; //Normalfall s[k]=' ';
        n := 1;
        if s[k] = ' ' then s[k] := #13 else BEGin
          k := k + j; //wieder rckgngig
          s := copy(s, 1, k) + #13#10 + copyab(s, k + 1);
          ls := ls + 2;
        END
      ENd;
    End;
  Finally
    s := AdjustLineBreaks(s); //#13 wird ersetzt durch #13#10
  End;
end;

function exe_Etc_Datei(pfad: string): boolean;
begin
  pfad := lowercase(extractfileext(pfad));
  result := (pfad = '.exe') or
            (pfad = '.dll') or
            (pfad = '.dcu') or
            (pfad = '.bin') or
            (pfad = '.wav') or
            (pfad = '.mp3') or
            (pfad = '.bmp') or
            (pfad = '.gif') or
            (pfad = '.jpg');
end;

end.
