{$I DebuggerAnAus.pas}
unit Unit2Sonderz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TForm2 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

 const Eingabezeichen = 'hspZi<>w#EKG~u"&+SPIabgDe-x';
       HTMLZeichen = '<br>'#13+
                      '&nbsp;'#13+
                      '<pre class=bruch>'#13+
                      '<div style="page-break-before:always"></div>'#13+
                      '<i> </i>'#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13+
                      ''#13#13;
        Erlaeuterung = 'Einfach: h h'#13+
                       'Leerstelle'#13+
                       'Fr Mathematiker (css entsprechend)'#13+
                       'Neue Seite'#13+
                       'Schrgschrift'#13+
                       '"<" in HTML nicht erlaubt. Nach dem Speichern: &lt;'#13+
                       '">" in HTML nicht erlaubt. Nach dem Speichern: &glt'#13+
                       'Wurzel->&radic (wird nach Dem Speichern HTM-Konform zu &radic'#13+
                       'ungleich          -> &ne;'#13+
                       'EUR               -> &euro;'#13+
                       'kleiner gleich    -> &le;'#13+
                       'grer gleich     -> &ge;'#13+
                       'beinahe gleich    -> &asymp;'#13+
                       'unendlich         -> &infin;'#13+
                       'Anfhrungszeichen -> &quot;'#13+
                       'kaufmnnisches Und-> &amp;'#13+
                       'plusminus-Zeichen -> &plusmn;'#13+
                       'Summe             ->&sum;'#13+
                       'Pi                -> &pi;'#13+
                       'Integral          -> &int;'#13+
                       'alpha klein       -> &alpha;'#13+
                       'beta klein        -> &beta;'#13+
                       'gamma klein       -> &gamma;'#13+
                       'Delta gro        -> &Delta;'#13+
                       'epsilon klein     -> &epsilon;'#13+
                       'berstrich        -> &oline;'#13+
                       'Mal-Zeichen       -> &times;'#13#13;

var
  Form2: TForm2;
  Form2Rueckabe: string;

implementation
uses Unit_ttText_hilf, Unit_ttText_wav;
{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
  var k: integer;
      pu1, pu2: Tstringlist;
begin
  top := 0;
  with stringgrid1 do Begin
    ColWidths[0] := 30;
    ColWidths[1] := 60;
    ColWidths[2] := 110;
    width := 210;
    form2.ClientWidth := 210;
    left := screen.Width - 220;
    cells[ 0,0] := 'Taste';
    cells[ 1,0] := 'HTML';
    cells[ 2,0] := 'Bemerkung';
  End;
  pu1 := Tstringlist.Create;
  pu2 := Tstringlist.Create;
  try
    pu1.Text := adjustlinebreaks(HTMLZeichen);
    pu2.Text := adjustlinebreaks(Erlaeuterung);
    for k := 1 to length(Eingabezeichen) do with stringgrid1 do Begin
      rowcount := k + 1;
      cells[0,k] := Eingabezeichen[k];
      cells[1,k] := pu1[k-1];
      cells[2,k] := pu2[k-1];
    End;
    finally pu1.free; pu2.free End;
   Height := stringgrid1.DefaultRowHeight * (stringgrid1.Rowcount+5);
end;

procedure TForm2.StringGrid1KeyPress(Sender: TObject; var Key: Char);
  var k: integer;
begin
   Case key of #8: key := 'h';
               #19: key := 's';
               #16: key :='p';
               #9: key := 'i';
   End;
   if key = #27 then Begin
     Form2Rueckabe := #27;
     close;
   End;
   with stringgrid1 do
     for k := 1 to Rowcount do
       if char(key) = cells[0,k] then Begin
         Form2Rueckabe := cells[1,k];
         close;
         exit;
       End;
   tontief;
end;

end.
