{$I DebuggerAnAus.pas}
unit Unit9tabelle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls, Grids, Menus;

type
  TForm9tabelle = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    EKopfzeile: TEdit;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StringGrid1: TStringGrid;
    PopupMenu1: TPopupMenu;
    returnZeiletiefer1: TMenuItem;
    returnSpalteweiterrechts1: TMenuItem;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Eueber: TEdit;
    Label5: TLabel;
    Eunter: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure returnZeiletiefer1Click(Sender: TObject);
    procedure returnSpalteweiterrechts1Click(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form9Tabelle: TForm9tabelle;
  RueckabeForm9: string;
implementation
uses Unit_ttText_hilf;

{$R *.DFM}
function SchreibealsHtmlCode: string;
  var RowMax,ColMax, i,j: integer;
      s,THodertd1, THodertd2, NeueZeileUnd6Leerstellen: string;
      pu: Tstringlist;
  function AlleSpaltenleer(n: integer): boolean;
      var k: integer;
    begin
      result := true;
      with Form9tabelle.stringgrid1 do
        for k := 0 to Colcount - 1 do
          if cells[k,n] <> '' then BEgin
            result := false;
            exit;
        END;
    end;
    function AlleReihenleer(n: integer): boolean;
      var k: integer;
    begin
      result := true;
      with Form9tabelle.stringgrid1 do
        for k := 0 to Rowcount - 1 do
          if cells[n,k] <> '' then BEgin
            result := false;
            exit;
        END;
    end;
begin
  with Form9tabelle.stringgrid1 do Begin
    Rowmax := Rowcount - 1;
    while (Rowmax >0) and AlleSpaltenleer(Rowmax) do dec(Rowmax);
    colmax := Colcount -1;
    while (Colmax >0) and AlleReihenleer(Colmax) do dec(Colmax);
    //<table>
    result := '<table';
    if Form9tabelle.SpinEdit1.Value > 0 then
      result := result + ' border=' + intToStr(Form9tabelle.SpinEdit1.Value);
    if Form9tabelle.checkbox2.checked then
      result := result + ' align=center';
    result := result + '>';
    //berschift
    if Form9tabelle.eueber.Text > '' then
      result := result + '<caption align=top>' +  Form9tabelle.eueber.Text;
    //Unterschrift
    if Form9tabelle.eunter.Text > '' then
      result := result + '<caption align=bottom>' +  Form9tabelle.eunter.Text;
    //Kopfzeile
    if Form9tabelle.EKopfzeile.text > '' then
    result := result + #13#10+
      '<th colspan=' + IntToStr(colmax) + '>' + Form9tabelle.EKopfzeile.text + '</th>';
    for i := 1 {0 unsichtbar} to Rowmax do BEgin
      if not Form9tabelle.CheckBox4.checked then
        s:='  <tr>' else
          s:='  <tr>'#13#10 + '    ';
      if (i=1) and (Form9tabelle.CheckBox1.checked) then BEGin
        THoderTD1 := '<th';
        THodertd2 := '</th>';
      END else Begin
        THoderTD1 := '<td';
        THoderTD2 := '</td>';
      End;
      if not Form9tabelle.CheckBox4.checked then BEGin
         THoderTD1 := #13#10 + '    ' + THoderTD1;
         THoderTD2 := #13#10 + '    ' + THoderTD2;
         NeueZeileUnd6Leerstellen := #13#10 + '      ';
      End else NeueZeileUnd6Leerstellen := '';
      if Form9tabelle.checkbox3.checked then
        THoderTD1 := THoderTD1 + ' align=center';
      for j := 1{o unsichtbar} to Colmax do BEgin
        if NurSpaces(cells[j,i]) then
          s := s + THoderTD1 +'>' + NeueZeileUnd6Leerstellen + '&nbsp;' + THoderTD2 else
            s := s + THoderTD1 + '>'+ NeueZeileUnd6Leerstellen + cells[j,i] + THoderTD2;
      ENd;
      s := s + #13#10'  </tr>';
      result := result + #13#10+ s;
    END;
    result := result + #13#10+ '</table>';
  End;
  with Form9tabelle.SpinEdit2 do
    if value > 0 then Begin
      pu := tstringlist.Create;
      try
        pu.Text := result;
        for i := 0 to pu.Count - 1 do
          pu[i] := copy(spaces80,1,value) + pu[i];
        result := pu.text;
      finally pu.free End;
    End;
end;


procedure TForm9tabelle.Button1Click(Sender: TObject);
begin
  RueckabeForm9 := SchreibealsHtmlCode;
  close;
end;

procedure TForm9tabelle.Button2Click(Sender: TObject);
begin
 RueckabeForm9 := #27;
 close;
end;

procedure TForm9tabelle.Button3Click(Sender: TObject);
   var k,j: integer;
begin
  Ekopfzeile.Text := '';
  with stringgrid1 do
    for k := 0 to Rowcount - 1 do
      for j := 0 to colcount - 1 do cells[j,k] := '';

end;

procedure TForm9tabelle.returnZeiletiefer1Click(Sender: TObject);
begin
  popupmenu1.Items[0].Checked  := false;
  popupmenu1.Items[1].Checked  := true;

end;

procedure TForm9tabelle.returnSpalteweiterrechts1Click(Sender: TObject);
begin
  popupmenu1.Items[0].Checked  := true;
  popupmenu1.Items[1].Checked  := false;
end;

procedure TForm9tabelle.StringGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
   procedure IncColCount;
   begin
     with stringgrid1 do
       if Col >= ColCount - 1 then ColCount := ColCount + 1;
   end;
   procedure IncRowCount;
   begin
     with stringgrid1 do
       if Row >= RowCount - 1 then RowCount := RowCount + 1;
   end;

begin
  with stringgrid1 do Begin
  if key = vk_down then IncRowCount;
  if key = vk_right then IncColCount;
  if key = 13 then if popupmenu1.items[0].checked then
    Begin IncColCount; col := col + 1 End else
    Begin IncRowCount; Row := Row + 1 End
  End;
end;

procedure TForm9tabelle.FormCreate(Sender: TObject);
begin
  stringgrid1.ColWidths[0] := 10;
  stringgrid1.RowHeights[0] := 10;
end;

end.
