{$I DebuggerAnAus.pas}
unit Unit3webtxt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, SHDocVw, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm3 = class(TForm)
    MainMenu1: TMainMenu;
    RichEdit1: TRichEdit;
    Splitter1: TSplitter;
    WebBrowser1: TWebBrowser;
    Aktualisieren1: TMenuItem;
    Datei1: TMenuItem;
    ffnen1: TMenuItem;
    Beenden1: TMenuItem;
    speichern1: TMenuItem;
    N1: TMenuItem;
    HTML1: TMenuItem;
    Tabletagsfarbig1: TMenuItem;
    Tabletagseinrcken1: TMenuItem;
    Listentagsfarbig1: TMenuItem;
    Listentagseinrcken1: TMenuItem;
    Linksblau1: TMenuItem;
    N2: TMenuItem;
    preetcfarbig1: TMenuItem;
    etclesbar1: TMenuItem;
    etcHTMLCode1: TMenuItem;
    N3: TMenuItem;
    berflssigeLeerstellenentfernen1: TMenuItem;
    kk1: TMenuItem;
    Berabeiten1: TMenuItem;
    Seitenansicht1: TMenuItem;
    VollerBildschirm1: TMenuItem;
    Zurck1: TMenuItem;
    Vor1: TMenuItem;
    abbrechen1: TMenuItem;
    Bausteine1: TMenuItem;
    HtmlGrest1: TMenuItem;
    Tabelleeinfgen1: TMenuItem;
    Listeeinfgen1: TMenuItem;
    Aufzhlungslisteeinfgen1: TMenuItem;
    Definitionslisteeinfgen1: TMenuItem;
    Image1: TImage;
    Bildeinfgen1: TMenuItem;
    Linkeinfgen1: TMenuItem;
    StatusBar1: TStatusBar;
    TextderFzeilekopieren1: TMenuItem;
    bretc1: TMenuItem;
    Suchen1: TMenuItem;
    N6: TMenuItem;
    Browser1: TMenuItem;
    N5: TMenuItem;
    Weitersuchen1: TMenuItem;
    Extras1: TMenuItem;
    Dateienexplorer1: TMenuItem;
    berschrift1: TMenuItem;
    berschriftkleinerlinks1: TMenuItem;
    Kommentar1: TMenuItem;
    Linie1: TMenuItem;
    Abschnitt1: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Zeilelschen1: TMenuItem;
    Zeielwiederzufgen1: TMenuItem;
    Zeilenpufferlschen1: TMenuItem;
    Zeielnpufferbearbeiten1: TMenuItem;
    N4: TMenuItem;
    Drucken1: TMenuItem;
    GreanDruckanpassen1: TMenuItem;
    N11: TMenuItem;
    procedure ffnen1Click(Sender: TObject);
    procedure Aktualisieren1Click(Sender: TObject);
    procedure Beenden(Sender: TObject);
    procedure speichern1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Tabletagsfarbig1Click(Sender: TObject);
    procedure Listentagsfarbig1Click(Sender: TObject);
    procedure Tabletagseinrcken1Click(Sender: TObject);
    procedure Listentagseinrcken1Click(Sender: TObject);
    procedure Linksblau1Click(Sender: TObject);
    procedure preetcfarbig1Click(Sender: TObject);
    procedure etclesbar1Click(Sender: TObject);
    procedure berflssigeLeerstellenentfernen1Click(Sender: TObject);
    procedure kk1Click(Sender: TObject);
    procedure WebBrowser1TitleChange(Sender: TObject;
      const Text: WideString);
    procedure RichEdit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Seitenansicht1Click(Sender: TObject);
    procedure VollerBildschirm1Click(Sender: TObject);
    procedure Zurck1Click(Sender: TObject);
    procedure Vor1Click(Sender: TObject);
    procedure abbrechen1Click(Sender: TObject);
    procedure Tabelleeinfgen1Click(Sender: TObject);
    procedure Listeeinfgen1Click(Sender: TObject);
    procedure Aufzhlungslisteeinfgen1Click(Sender: TObject);
    procedure Definitionslisteeinfgen1Click(Sender: TObject);
    procedure Bildeinfgen1Click(Sender: TObject);
    procedure Linkeinfgen1Click(Sender: TObject);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TextderFzeilekopieren1Click(Sender: TObject);
    procedure bretc1Click(Sender: TObject);
    procedure Suchen1Click(Sender: TObject);
    procedure etcHTMLCode1Click(Sender: TObject);
    procedure Dateienexplorer1Click(Sender: TObject);
    procedure berschrift1Click(Sender: TObject);
    procedure berschriftkleinerlinks1Click(Sender: TObject);
    procedure Kommentar1Click(Sender: TObject);
    procedure Linie1Click(Sender: TObject);
    procedure Abschnitt1Click(Sender: TObject);
    procedure Zeilelschen1Click(Sender: TObject);
    procedure Zeielwiederzufgen1Click(Sender: TObject);
    procedure Zeilenpufferlschen1Click(Sender: TObject);
    procedure Zeielnpufferbearbeiten1Click(Sender: TObject);
    procedure Drucken1Click(Sender: TObject);
    procedure GreanDruckanpassen1Click(Sender: TObject);
    procedure HtmlGrest1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form3: TForm3;
  UebergabeStringVonForm3: string;

procedure ZeigeForm3Beides(const titel, satz: string; art: integer);
procedure zeichneViolinschluessel(a,b: integer; canv: Tcanvas);


implementation

uses clipbrd, Unit1, unit9tabelle, Unit_ttText_html, Unit_ttText_hilf, Unit_ttText_wav,
     Unit_ttText_ini, Unit2h, unit8memo, Unit10explorer, Unit6einstellungen,
  Unit13;

{$R *.DFM}



procedure zeigeTextForm3(ueberschrift: string; satz: String; art: integer);
begin
  satz := AdjustLineBreaks(satz); //#13 wird ersetzt durch #13#10
  //if length(satz) < 20000 then satz := MitLeerstellenaufgefuellt(satz);
  form3.caption := ueberschrift;
  form3.RichEdit1.Lines.Clear;
  form3.richedit1.text := satz;
  Case art of  999: Begin
                      HTML_table_farbig(form3.Richedit1);
                      HTML_listen_farbig(form3.Richedit1);
                      HTML_links_farbig(form3.Richedit1);
                      HTML_pre_farbig(form3.Richedit1);
                    End;
                 1: HTML_table_farbig(form3.Richedit1);
                 2: HTML_listen_farbig(form3.Richedit1);
                 3: HTML_links_farbig(form3.Richedit1);
  End;
  schriftsetzten(form3.richedit1);
  if form3.Visible then form3.Close;
  form3.ShowModal;
end;

procedure zeigeimBrowserForm3(satz: string; refresh: boolean);
   const
     fuss='</body></html>';
   var dummy: string;
       pu: Tstringlist;
   function kopf: string;
     begin
       result := '<html><head><title></title></head><body style="margin-top:' +
         leseIni(SectionEinstellungen,schluesselRandoben) + 'mm; margin-left:' +
         leseIni(SectionEinstellungen,schluesselRandlinks) + 'mm; margin-right:' +
         leseIni(SectionEinstellungen,schluesselRandrechts) + 'mm;">';
     end;
begin
  dummy := adjustlinebreaks(satz);
  ConvertTTWCharHTML(dummy);
  pu := Tstringlist.Create;
  try
    if pos('<html',satz) > 0 then pu.text := dummy else
      pu.text := kopf+#13#10+dummy+#13#10+fuss;
    pu.SaveToFile(TmpHtmlImOrdner);
  finally pu.free End;
  try
  if refresh then Form3.WebBrowser1.refresh else
    Form3.WebBrowser1.Navigate(WideString(TmpHtmlImOrdner))
  except Form3.WebBrowser1.Navigate(WideString(TmpHtmlImOrdner)) End;
end;

procedure ZeigeForm3Beides(const titel, satz: string; art: integer);
begin
  zeigeimBrowserForm3(satz, false);
  zeigeTextForm3(titel,satz,art);
end;


procedure TForm3.ffnen1Click(Sender: TObject);
begin
  if form1.opendialog1.Execute then
     richedit1.Lines.LoadFromFile(form1.opendialog1.filename);
end;

procedure TForm3.Aktualisieren1Click(Sender: TObject);
begin
   zeigeimBrowserForm3(richedit1.text, true);
end;

procedure TForm3.Beenden(Sender: TObject);
begin
  if form1.tabcontrol1.Tabs.Count = 0 then neueneditor;
  editor[form1.tabcontrol1.tabindex].SelText := richedit1.text + #13#10;
  close;
end;


procedure TForm3.speichern1Click(Sender: TObject);
begin
  if Form1.savedialog1.execute then
     richedit1.Lines.SaveToFile(Form1.savedialog1.filename);
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  setbounds(0,0,screen.Width, screen.Height);
end;

procedure TForm3.Tabletagsfarbig1Click(Sender: TObject);
begin
   HTML_table_farbig(Richedit1);
end;

procedure TForm3.Listentagsfarbig1Click(Sender: TObject);
begin
    HTML_listen_farbig(Richedit1);
end;

procedure TForm3.Tabletagseinrcken1Click(Sender: TObject);
begin
   HTML_table_eingerueckt(richedit1);
end;

procedure TForm3.Listentagseinrcken1Click(Sender: TObject);
begin
   HTML_listen_eingerueckt(richedit1);
end;

procedure TForm3.Linksblau1Click(Sender: TObject);
begin
  HTML_links_farbig(Richedit1);
end;

procedure TForm3.preetcfarbig1Click(Sender: TObject);
begin
  HTML_pre_farbig(Richedit1);
end;

procedure TForm3.etclesbar1Click(Sender: TObject);
   var k: integer;
       s: string;
begin
  for k := 0 to  richedit1.Lines.Count - 1 do Begin
    s := richedit1.lines[k];
    ConvertHTMLChar(s);
    richedit1.lines[k] := s;
  End;
end;

procedure TForm3.berflssigeLeerstellenentfernen1Click(Sender: TObject);
begin
  entferneLeerzeichenUndLeerZeilen(richedit1);
end;

procedure TForm3.kk1Click(Sender: TObject);
   var e: Trichedit;
      k, Zeile, Spalte: integer;
begin
  e := richedit1;
  Zeile := SendMessage(e.Handle, EM_LINEFROMCHAR, e.SelStart,0);
  Spalte := SendMessage(e.Handle, EM_LINEINDEX, Zeile, 0);
  for k := e.Lines.Count - 1 downto 0 do
    if length(e.lines[k]) < 80 then
      e.Lines[k] := e.lines[k] + copy(spaces80,1,80 - length(e.lines[k]));
  setCursor(e,zeile,spalte);
end;

procedure TForm3.WebBrowser1TitleChange(Sender: TObject;
  const Text: WideString);
begin
   caption := text;
end;

procedure TForm3.RichEdit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  zeichneLinie(Richedit1);
end;

procedure TForm3.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  zeichneLinie(Richedit1);
end;

procedure TForm3.Seitenansicht1Click(Sender: TObject);
begin
  WebBrowser1.Align := alNone;
  webbrowser1.width := 818;
end;

procedure TForm3.VollerBildschirm1Click(Sender: TObject);
begin
  WebBrowser1.Align := alclient;
end;

procedure TForm3.Zurck1Click(Sender: TObject);
begin
   try webbrowser1.goBack except End;
end;

procedure TForm3.Vor1Click(Sender: TObject);
begin
  try webbrowser1.goForward except End;
end;

procedure TForm3.abbrechen1Click(Sender: TObject);
begin
  close;
end;

procedure einfuegen(const s: string);
begin
  with form3.RichEdit1 do Begin
    sellength := 0;
    seltext := AdjustLineBreaks(s)+#13#10;
  zeigeimBrowserForm3(text, true);
  End;
end;


procedure TForm3.Tabelleeinfgen1Click(Sender: TObject);
begin
  form9tabelle.Top := 0;
  form9tabelle.showmodal;
  if RueckabeForm9 <> #27 then einfuegen(RueckabeForm9);
end;

procedure TForm3.Listeeinfgen1Click(Sender: TObject);
begin
  einfuegen(
'<ol type=a start=1>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'</ol>');

ok('Krzer: mit Strg+H+9 und Str+H+l'#13+
    'Mglichkeiten fr type:1 a A I i');
end;

procedure TForm3.Aufzhlungslisteeinfgen1Click(Sender: TObject);
begin
  einfuegen(
'<ul type=disk>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'  <li> </li>'#13+
'</ul>');
ok('Krzer: mit Strg+H+0 (Null) und Str+H+l (klein L)'#13+
   'Mglichkeiten fr type: square circle disc');

end;

procedure TForm3.Definitionslisteeinfgen1Click(Sender: TObject);
begin
  einfuegen(
'<dl>'#13+
'  <dd> </dd>'#13+
'  <dd> </dd>'#13+
'  <dd> </dd>'#13+
'  <dd> </dd>'#13+
'</dl>');

ok('Krzer: mit Strg+H+8 und Str+H+l (klein l)');

end;

procedure zeichneViolinschluessel(a,b: integer; canv: Tcanvas);
 const
   schluessel =
      '         ++'#13#10+
      '        ++++'#13#10+
      '        ++++'#13#10+
      '       +++ +'#13#10+
      '       ++   +'#13#10+
      '       ++   +'#13#10+
      '      ++    +'#13#10+
      '      ++    +'#13#10+
      '      +    ++'#13#10+
      '      ++   ++'#13#10+
      '      ++  +++'#13#10+
      '      ++  +++'#13#10+
      '       + +++'#13#10+
      '       +++++'#13#10+
      '       ++++'#13#10+
      '      ++++'#13#10+
      '     ++++'#13#10+
      '    +++++'#13#10+
      '   ++++++'#13#10+
      '  +++++ +'#13#10+
      '  +++   +'#13#10+
      ' ++++    +'#13#10+
      ' ++      +++'#13#10+
      ' ++    +++++'#13#10+
      '+++   +++++++++'#13#10+
      '++    ++++ +++++'#13#10+
      '++   +++  +  +++'#13#10+
      '++    +   +   ++'#13#10+
      '++    +   +    +'#13#10+
      ' +    +   +    +'#13#10+
      ' +    +   +    +'#13#10+
      ' ++   ++   +   +'#13#10+
      '  ++    +  +  ++'#13#10+
      '   ++      + ++'#13#10+
      '     ++    ++'#13#10+
      '       +++++'#13#10+
      '           +'#13#10+
      '           ++'#13#10+
      '            +'#13#10+
      '      +     +'#13#10+
      '    +++++   +'#13#10+
      '    +++++   +'#13#10+
      '    +++++   +'#13#10+
      '    +++++   +'#13#10+
      '    +++    ++'#13#10+
      '     +++ +++';
  var i,j: integer;
      puffer: Tstringlist;
begin
  puffer := Tstringlist.Create;
  try
    puffer.Text := schluessel;
    with canv do
      for i := 0 to puffer.Count - 1 do
        for j := 1 to length(puffer[i]) do
          if puffer[i][j] <> ' ' then Pixels[j+a,i+b] := clblack;
  finally puffer.Free End;
end;

procedure TForm3.Bildeinfgen1Click(Sender: TObject);
  var pfad: string;
begin
  pfad := lowercase(ChangeFileExt(extractfilename(paramstr(0)),'.bmp'));
  zeichneViolinschluessel(0,0, image1.Canvas);
  image1.Picture.SaveToFile(pfad);
  einfuegen('<img src="' + pfad + '" width="105" height="105" alt="violinschluessel">');
end;

procedure TForm3.Linkeinfgen1Click(Sender: TObject);
  var pu: Tstringlist;
    pfad: string;
begin
  pfad := lowercase(ChangeFileExt(extractfilename(paramstr(0)),'.html'));
  pu := Tstringlist.Create;
  try
    pu.text := '<html><body><h1>Zurck mit F4</h1></body></html>';
    pu.SaveToFile(pfad);
  finally pu.free End;
  einfuegen(
  '<a href="'+pfad+'">Link</a>');
end;
procedure TForm3.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  StatusBar1.SimpleText :=text;
end;

procedure TForm3.TextderFzeilekopieren1Click(Sender: TObject);
begin
   clipboard.AsText := StatusBar1.SimpleText;
end;

procedure TForm3.bretc1Click(Sender: TObject); //hnliche Prozedur unit1
begin
  StrgH_Sonderzeichen(richedit1);
end;

procedure TForm3.Suchen1Click(Sender: TObject);
begin
    if sender = Suchen1 then Durchsuche(Richedit1,true) else
      Durchsuche(richedit1, false);
end;

procedure TForm3.etcHTMLCode1Click(Sender: TObject);
   var k: integer;
       s: string;
begin
  for k := 0 to  richedit1.Lines.Count - 1 do Begin
    s := richedit1.Lines[k];
    ConvertTTWCharHTML(s);
    richedit1.Lines[k] := s;
  End;
end;
procedure TForm3.Dateienexplorer1Click(Sender: TObject);
begin
  form10explorer1.Form10explorerStart;
  form10explorer1.show;
end;

procedure TForm3.berschrift1Click(Sender: TObject);
begin
  einfuegen(
  '<h1 align=center></h1>');
  richedit1.selstart := Richedit1.selstart - 7;
end;

procedure TForm3.berschriftkleinerlinks1Click(Sender: TObject);
begin
  einfuegen(
  '<h2></h2>');
   richedit1.selstart := Richedit1.selstart - 7;
end;

procedure TForm3.Kommentar1Click(Sender: TObject);
begin
   einfuegen('<!--   -->');
   richedit1.selstart := Richedit1.selstart - 7;
end;

procedure TForm3.Linie1Click(Sender: TObject);
begin
    einfuegen('<hr>');
end;

procedure TForm3.Abschnitt1Click(Sender: TObject);
begin
    einfuegen('<p></p>');
    richedit1.selstart := Richedit1.selstart - 6;
end;

procedure TForm3.Zeilelschen1Click(Sender: TObject);
  var zeile, spalte{dummy}: integer;
      e: TRichedit;
begin
  e := Richedit1;
  ErmittleZeileUndSpalte(e, zeile, spalte);
  loeschpuffer.Add(e.lines[zeile - 1]);
  if zeile > 0 then e.Lines.Delete(zeile-1);
end;
procedure TForm3.Zeielwiederzufgen1Click(Sender: TObject);
  var zeile, spalte{dummy},altselstart: integer;
      e: TRichedit;
begin
  if loeschpuffer.Count = 0 then Begin
    ok('Puffer leer');
    exit;
  end;
  e := Richedit1;
  ErmittleZeileUndSpalte(e, zeile, spalte);
  altselstart := e.SelStart;
  e.Lines.Insert(zeile - 1,loeschpuffer[loeschpuffer.count - 1]);
  loeschpuffer.Delete(loeschpuffer.count - 1);
  e.SelStart := altselstart;
end;

procedure TForm3.Zeilenpufferlschen1Click(Sender: TObject);
begin
   loeschpuffer.Clear;
end;

procedure TForm3.Zeielnpufferbearbeiten1Click(Sender: TObject);
begin
   BearbeiteForm8('Zeilenpuffer',loeschpuffer.text);
   if UebergabeStringVonForm8 = Form8Abbruch then exit;
   loeschpuffer.text := UebergabeStringVonForm8;
end;

procedure TForm3.Drucken1Click(Sender: TObject);
 var x: Olevariant;
begin
  Form6shomodalDasErsteMal('Sind Sie Rnder beim Drucken so richtig?');
  WebBrowser1.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, x, x);
end;

procedure TForm3.GreanDruckanpassen1Click(Sender: TObject);
begin
  left := 50;
  width := 818;
end;

procedure TForm3.HtmlGrest1Click(Sender: TObject);
begin
  ok('Bitte "Esc" und dort (gelb) Text in HTML-Gerst einbetten!'#13+
     'Grund: In diesem Bearbeitungsmodus wird nicht immer der ganze Text bearbeitet.');

end;

end.
