{$I DebuggerAnAus.pas}
unit Unit5web;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, OleCtrls, SHDocVw, ExtCtrls, ComObj, ComCtrls;

type
  TForm5 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    VonFestplatteladen1: TMenuItem;
    ZurckzumHauptprogramm1: TMenuItem;
    Panel1: TPanel;
    Edit1: TEdit;
    WebBrowser1: TWebBrowser;
    Bearbeiten1: TMenuItem;
    Seitenansicht1: TMenuItem;
    VollerBildschirm1: TMenuItem;
    N1: TMenuItem;
    Zurck1: TMenuItem;
    Vor1: TMenuItem;
    EinstellungenimMSExplorer1: TMenuItem;
    N2: TMenuItem;
    RechtschreibprfunginMSWord1: TMenuItem;
    StatusBar1: TStatusBar;
    TextderStatusbarinsEditfeldkopieren1: TMenuItem;
    Aktualisieren1: TMenuItem;
    Extras1: TMenuItem;
    FensterimmerimVordergrund1: TMenuItem;
    Fafvoriten1: TMenuItem;
    LinkdenFavoritenzufgen1: TMenuItem;
    Favoritenlistebearbeiten1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Druckervorschau1: TMenuItem;
    Drucken1: TMenuItem;
    N5: TMenuItem;
    EinstellungenDruckerberMS1: TMenuItem;
    Quelltext1: TMenuItem;
    N6: TMenuItem;
    Teildrucken1: TMenuItem;
    TextderStatusbarkopieren1: TMenuItem;
    procedure MenuHandlerFavoriten(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ZurckzumHauptprogramm1Click(Sender: TObject);
    procedure WebBrowser1TitleChange(Sender: TObject;
      const Text: WideString);
    procedure Seitenansicht1Click(Sender: TObject);
    procedure VollerBildschirm1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure VonFestplatteladen1Click(Sender: TObject);
    procedure Zurck1Click(Sender: TObject);
    procedure Vor1Click(Sender: TObject);
    procedure EinstellungenimMSExplorer1Click(Sender: TObject);
    procedure RechtschreibprfunginMSWord1Click(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TextderStatusbarinsEditfeldkopieren1Click(Sender: TObject);
    procedure aktualisieren1Click(Sender: TObject);
    procedure FensterimmerimVordergrund1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Favoritenlistebearbeiten1Click(Sender: TObject);
    procedure LinkdenFavoritenzufgen1Click(Sender: TObject);
    procedure Drucken1Click(Sender: TObject);
    procedure Druckervorschau1Click(Sender: TObject);
    procedure Quelltext1Click(Sender: TObject);
    procedure Teildrucken1Click(Sender: TObject);
    procedure TextderStatusbarkopieren1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const Favoritenvorgabe =
'http://delphi.zsg-rottenburg.de'#13#10+
'-'#13#10+
'http://groups.google.com'#13#10+
'http://service.t-online.de/shar/such'#13#10+
'-'#13#10+
'www.teleauskunft.de'#13#10+
'www.gelbe-seiten.de'#13#10+
'http://www.email-verzeichnis.de'#13#10+
'http://bahn.hafas.de'#13#10+
'www.efa-bw.de'#13#10+
'http://www.telefonbuch.de';


var
  Form5: TForm5;

implementation

uses  MSHTML, clipbrd, Unit1, unit3webtxt, unit8memo, Unit_ttText_hilf, Unit_ttText_wav, Unit_ttText_ini;

{$R *.DFM}

procedure TForm5.MenuHandlerFavoriten(Sender: TObject);
  var pfad: string;
begin
  pfad := OhneEt((Sender as Tmenuitem).caption);
  WebBrowser1.Navigate(WideString(pfad));
  Edit1.text := pfad;
  Top := 35;
  Height := screen.Height - 35;
  Show; //wird auch von Form1 aufgerufen
end;

procedure UntermenuErzeugenfuerFavoitenForm5(s: string);
var Item: TMenuItem;
begin
  Item := TMenuItem.Create(Form5);
  Item.Caption := s;
  Item.OnClick := Form5.MenuHandlerFavoriten;
  item.Enabled := true;
  form5.MainMenu1.Items[MainMenuitemindex(form5.MainMenu1,'Favoriten')].Add(Item);
end;

procedure UntermenuErzeugenfuerFavoitenForm1(s: string);
var Item: TMenuItem;
begin
  Item := TMenuItem.Create(Form1);
  Item.Caption := s;
  Item.OnClick := Form5.MenuHandlerFavoriten; //in Form5 bleibt!!
  item.Enabled := true;
  form1.MainMenu1.Items[MainMenuitemindex(form1.MainMenu1,'Favoriten')].Add(Item);
end;

procedure FavoritenDenMenuezufuegen;
  var pu: Tstringlist;
       k: integer;
begin
  Pu := TStringlist.Create;
  try
    pu.text := LeseINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten);
    if pu.Count = 0 then Begin
      pu.Text := Favoritenvorgabe;
      SchreibeINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten,
        Favoritenvorgabe);
    End;
    for k := 0 to pu.count - 1 do Begin
      UntermenuErzeugenfuerFavoitenform5(pu[k]);
      UntermenuErzeugenfuerFavoitenform1(pu[k]);
    End;
  finally pu.free End;
end;

procedure TForm5.FormCreate(Sender: TObject);
begin
  top := 0;
  left := 0;
  width := screen.Width;
  height := screen.Height;
  edit1.Width := screen.Width;
  FavoritenDenMenuezufuegen;
end;

procedure TForm5.ZurckzumHauptprogramm1Click(Sender: TObject);
begin
  close;
end;

procedure TForm5.WebBrowser1TitleChange(Sender: TObject;
  const Text: WideString);
begin
  if text <> 'about:blank' then caption := text else Caption := ''
end;

procedure TForm5.Seitenansicht1Click(Sender: TObject);
begin
  top := 0;
  left := 40;
  width := 818;
end;

procedure TForm5.VollerBildschirm1Click(Sender: TObject);
begin
  top := 0;
  left := 0;
  width := screen.width;
end;

procedure TForm5.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
     WebBrowser1.Navigate(WideString(edit1.text));
end;

procedure TForm5.VonFestplatteladen1Click(Sender: TObject);
begin
   with form1.OpenDialog1 do Begin
     if form1.tabcontrol1.Tabs.Count > 0 then BEgin
        Initialdir:=extractFilepath(gpfad[form1.tabcontrol1.tabindex]);
        filename:=extractFilename(gpfad[form1.tabcontrol1.tabindex]);
      ENd;
      if execute then BEgin
        edit1.Text := filename;
        WebBrowser1.Navigate(WideString(edit1.text));
      ENd;
   End;
end;



procedure TForm5.Zurck1Click(Sender: TObject);
begin
  try webbrowser1.goBack except End;
end;

procedure TForm5.Vor1Click(Sender: TObject);
begin
  try webbrowser1.goForward except End;
end;

procedure NavigierenMs18(url:string); //MicrosoftExplorer
  var e:OleVariant;
Begin
  try e:=CreateOleObject('InternetExplorer.Application'); //uses ComObj
  Except ok('Internetexplorer nicht installiert'); exit; End;
  try
    e.visible:=true;
    e.top:=25;
    e.left:=25;
    e.width:=screen.width;
    e.height:=screen.height;
    if url>'' then e.Navigate(url);
  except ok('Ms-Explorer streikt!'); End;
End;

procedure TForm5.EinstellungenimMSExplorer1Click(Sender: TObject);
begin
  try
    form5.top := 500; //wg stayonTop und Bebugger
    NavigierenMs18(edit1.text);
  finally form5.top := 0 End;  
end;

procedure TForm5.RechtschreibprfunginMSWord1Click(Sender: TObject);
  var V: OleVariant;
      pfadx: string;
begin
  try
    form5.top := 500;
    pfadx :=  lowercase(extractfiledir(paramstr(0)) + '\tmpx.html');
    Try V := GetActiveOleObject('Word.Basic')except
      TRy V := CreateOleObject('Word.Basic')except
       ok('Word steht nicht zur Verfgung:');
       exit;
     ENd;
   End;
   editor[enr].Lines.SaveToFile(pfadx);
   try V.FileOpen(Name := pfadx)
   except ok('Lies selbst mit Word ein!'); End;
    v.appshow;
   try
     v.AppMaximize;
     v.DocMaximize;
    Except End; //Nicht lebensnotwendig
    try v.ToolsOptionsSpelling(AutomaticSpellChecking := 1); except End;
  finally form5.top := 0 End;
end;
procedure TForm5.WebBrowser1NavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  if (url <> 'about:blank') and (pos('tmp.html',url) = 0) then
    edit1.Text := url else edit1.text := '';
end;

procedure TForm5.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  StatusBar1.SimpleText :=text;
end;

procedure TForm5.TextderStatusbarinsEditfeldkopieren1Click(
  Sender: TObject);
begin
  clipboard.astext := statusbar1.SimpleText;
end;

procedure TForm5.aktualisieren1Click(Sender: TObject);
begin
  Form1.ImBrowserzeigen1Click(Nil);
end;

procedure TForm5.FensterimmerimVordergrund1Click(Sender: TObject);
begin
  formstyle := fsstayontop;
end;

procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   formstyle := fsnormal;
end;

procedure TForm5.Favoritenlistebearbeiten1Click(Sender: TObject);
  var pu: Tstringlist;
begin
  Pu := TStringlist.Create;
  pu.text := LeseINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten);
  BearbeiteForm8('Makros und Einstellungen',Pu.text);
  if UebergabeStringVonForm8 = Form8Abbruch then exit;
  SchreibeINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten, UebergabeStringVonForm8);
  ok('Beim nchsten Start sind die Favoriten entsprechend gendert');
end;

procedure TForm5.LinkdenFavoritenzufgen1Click(Sender: TObject);
  var pu: Tstringlist;
begin
  Pu := TStringlist.Create;
  try
    pu.text := LeseINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten) + #13#10+
      edit1.Text;
    SchreibeINIStringlist(SektionundschluesselFavoriten, SektionundschluesselFavoriten, pu.text);
    ok('Beim nchsten Start ist der Link abrufbar.');
  finally pu.free End;
end;

procedure TForm5.Drucken1Click(Sender: TObject);
  var x: Olevariant;
begin
  WebBrowser1.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, x, x);
end;

procedure TForm5.Druckervorschau1Click(Sender: TObject);
begin
  left := 50;
  width := 818;
end;

procedure TForm5.Quelltext1Click(Sender: TObject);
var
  doc1 :IHTMLDocument2;  //uses    MSHTML;
     s :string;
begin
  try
    doc1:=webbrowser1.Document as IHTMLDocument2;
    NeuenEditor;
    s := doc1.body.parentElement.outerHTML;
    s := stringreplace(s,'<',#13#10+'<',[rfReplaceAll]);
    Zeilenumbrechen(s,120,false);
    editor[enr].text := copyab(s,3);
  except okfehler('Geht nicht!') End;
end;

procedure TForm5.Teildrucken1Click(Sender: TObject);
begin
   ok('Gehe zurck zum Hauptmen, markiere im Quelltext den zu druckenden Teil ' +
      'und drucke dann ber Men "Bearbeiten|Bausteine im Ausgewhlten einfgen..."');

end;

procedure TForm5.TextderStatusbarkopieren1Click(Sender: TObject);
begin
    clipboard.AsText := StatusBar1.SimpleText;
end;

end.
