{$I DebuggerAnAus.pas}
unit Unit_ttText_html;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls;

const
  MaxUmlaute = 90 - 5 - 4 - 2{֥}; //5 am Anfang und 2 am Ende wegggelassen

  Umlaute: Array [0..MaxUmlaute-1] of char =

({'<','>','&','"','=',}'','','','','','','','','','','','',

'','','','','','','','','','','','','','','','','',

'','','','','','','','','','','','','','','','','',

'',{'',}'','','','','','','','','','','','','','','',

'','','','','','','',{'',}'','','','','','','','','',

''{,'','','"','"'});

UmlauteInHtml: Array [0..MaxUmlaute-1] of string =

({'&lt;','&gt;','&amp;','&quot;','&nbsp;',}'&Ccedil;','&ccedil;','&Ntilde;',

'&ntilde;','&THORN;','&thorn;','&Yacute;','&yacute;','&yuml;','&szlig;',

'&AElig;','&Aacute;','&Acirc;','&Agrave;','&Aring;','&Atilde;','&Auml;',

'&aelig;','&aacute;','&acirc;','&agrave;','&aring;','&atilde;','&auml;',

'&ETH;','&Eacute;','&Ecirc;','&Egrave;','&Euml;','&eth;','&eacute;',

'&ecirc;','&egrave;','&euml;','&Iacute;','&Icirc;','&Igrave;','&Iuml;',
     '&iacute;','&icirc;','&igrave;','&iuml;','&Oacute;','&Ocirc;',
     '&Ograve;','&Oslash;','&Otilde;',{'&Ouml;',}'&oacute;','&ocirc;',

'&ograve;','&oslash;','&otilde;','&ouml;','&Uacute;','&Ucirc;','&Ugrave;',
     '&Uuml;','&uacute;','&ucirc;','&ugrave;','&uuml;','&reg;','&copy;',

'&plusmn;','&micro;','&para;','&middot;','&cent;','&pound;',{'&yen;',}

'&frac14;','&frac12;','&frac34;','&sup1;','&sup2;','&sup3;','&iquest;',
     '&deg;','&brvbar;','&sect;'{,'&laquo;','&raquo;','&#132;','&#147;'});

procedure ConvertHTMLChar(var s: string);
procedure ConvertTTWCharHTML(var s: string);
procedure SchreibeTagFarbig(e: Trichedit; const wort: string; farbe:TColor);
procedure HTML_table_farbig(e: Trichedit);
procedure HTML_table_eingerueckt(e: Trichedit);
procedure HTML_listen_farbig(e: Trichedit);
procedure HTML_links_farbig(e: Trichedit);
procedure HTML_pre_farbig(e: Trichedit);
procedure HTML_listen_eingerueckt(e: Trichedit);

implementation
  uses unit_ttText_hilf;

{         'w : Wurzel             &radic;'#13+
          '# : ungleich           &ne;'#13+
          'E : EUR                &euro;'#13+
          '< : kleiner als        &lt;'#13+
          '> : grer als         &gt;'#13+ //=TTWGroesser
          'K : kleiner gleich     &le;'#13+
          'G : grer gleich      &ge;'#13+
          '~ : beinahe gleich     &asymp;'#13+
          'u : unendlich          &infin;'#13+
          '" : Anfhrungszeichen  &quot;'#13+
          '& : kaufmnnisches Und &amp;'#13+
          'p : plusminus-Zeichen  &plusmn;'#13+
          'S : Summe              &sum;'#13+
          'I : Integral           &int;'#13+
          'a : alpha klein        &alpha;'#13+
          'b : beta klein         &beta;'#13+
          'g : gamma klein        &gamma;'#13+
          'D : Delta gro         &Delta;'#13+
          'e : epsilon klein      &epsilon;'#13+
          '- : berstrich         &oline;'#13+
          'x : Mal-Zeichen        &times;',true);
                Pfeil rechts &rarr; }
procedure ConvertTTWCharHTML(var s: string);
  var k: integer;
begin
  //s := StringReplace(s, '  ', '&nbsp;&gt;&nbsp;'  , [rfReplaceAll]);//siehe TTWGroesser
  //s := StringReplace(s, '  ', '&nbsp;&lt;&nbsp;'  , [rfReplaceAll]);
  //s := StringReplace(s, ' = ', '&nbsp;=&nbsp;'     , [rfReplaceAll]);
  //s := StringReplace(s, '-', '&mdash;&gt;',           [rfReplaceAll]);
  s := StringReplace(s, '', '&mdash;',                [rfReplaceAll]);
  s := StringReplace(s, '--', '&mdash;&mdash;',        [rfReplaceAll]);
  s := StringReplace(s, '&mdash;-', '&mdash;&mdash;',  [rfReplaceAll]);
                                    // da ein "-"  brigbleiben kann
  s := StringReplace(s, '', '&radic;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&ne;'     , [rfReplaceAll]);
  s := StringReplace(s, '', '&euro;'   , [rfReplaceAll]);
  s := StringReplace(s, '', '&lt;'     , [rfReplaceAll]);
  s := StringReplace(s, '', '&gt;'     , [rfReplaceAll]); //SDiehe TTWGroesser
  s := StringReplace(s, '', '&le;'     , [rfReplaceAll]);
  s := StringReplace(s, '', '&ge;'     , [rfReplaceAll]);
  s := StringReplace(s, '', '&asymp;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&infin;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&quot;'   , [rfReplaceAll]);
  s := StringReplace(s, '', '&amp;'    , [rfReplaceAll]);
  s := StringReplace(s, '', '&plusmn;' , [rfReplaceAll]);
  s := StringReplace(s, '', '&sum;'    , [rfReplaceAll]);
  s := StringReplace(s, '', '&pi;'     , [rfReplaceAll]);
  s := StringReplace(s, '', '&int;'    , [rfReplaceAll]);
  s := StringReplace(s, '', '&alpha;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&beta;'   , [rfReplaceAll]);
  s := StringReplace(s, '', '&gamma;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&Delta;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&epsilon;', [rfReplaceAll]);
  s := StringReplace(s, '', '&oline;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&times;'  , [rfReplaceAll]);
  s := StringReplace(s, '', '&middot;' , [rfReplaceAll]);
  s := StringReplace(s, '', '&#153;'   , [rfReplaceAll]);
  s := StringReplace(s, '', '<sup>2</sup>'  , [rfReplaceAll]);
  s := StringReplace(s, '', '<sup>3</sup>'  , [rfReplaceAll]);
  s := StringReplace(s, '<!&mdash;&mdash;','<!--',[rfReplaceAll]); //Kommentaranfang
  s := StringReplace(s, '&mdash;&mdash;>','-->',[rfReplaceAll]); //Kommentarende
  for k := 0 to MaxUmlaute - 1 do
     s := StringReplace(s, umlaute[k], UmlauteInHtml[k], [rfReplaceAll]);
end;

procedure ConvertHTMLChar(var s: string);
  var k:integer;
begin
  for k := 0 to MaxUmlaute - 1 do
    s := StringReplace(s, UmlauteInHtml[k], Umlaute[k], [rfReplaceAll]);
  s := StringReplace(s, '&nbsp;&gt;&nbsp;', '  '  , [rfReplaceAll]); //siehe TTWGroesser
  s := StringReplace(s, '&nbsp;&lt;&nbsp;', '  '  , [rfReplaceAll]);
  s := StringReplace(s, '&nbsp;=&nbsp;'   , ' = '  , [rfReplaceAll]);
  //s := StringReplace(s, '&mdash;&gt;'     , '-'   , [rfReplaceAll]);
  s := StringReplace(s, '&mdash;'         , '-'    , [rfReplaceAll]);
  s := StringReplace(s, '&radic;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&ne;',      '', [rfReplaceAll]);
  s := StringReplace(s, '&euro;',    '', [rfReplaceAll]);
  s := StringReplace(s, '&lt;',      '', [rfReplaceAll]);
  s := StringReplace(s, '&gt;',      '', [rfReplaceAll]); //siehe TTWGroesser
  s := StringReplace(s, '&le;',      '', [rfReplaceAll]);
  s := StringReplace(s, '&ge;',      '', [rfReplaceAll]);
  s := StringReplace(s, '&asymp;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&infin;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&quot;',    '', [rfReplaceAll]);
  s := StringReplace(s, '&amp;',     '', [rfReplaceAll]);
  s := StringReplace(s, '&plusmn;',  '', [rfReplaceAll]);
  s := StringReplace(s, '&sum;',     '', [rfReplaceAll]);
  s := StringReplace(s, '&pi;',      '', [rfReplaceAll]);
  s := StringReplace(s, '&int;',     '', [rfReplaceAll]);
  s := StringReplace(s, '&alpha;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&beta;',    '', [rfReplaceAll]);
  s := StringReplace(s, '&gamma;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&Delta;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&epsilon;', '', [rfReplaceAll]);
  s := StringReplace(s, '&oline;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&times;',   '', [rfReplaceAll]);
  s := StringReplace(s, '&middot;',     '', [rfReplaceAll]);
  s := StringReplace(s, '&#153;',       '', [rfReplaceAll]);
  s := StringReplace(s, '<sup>2</sup>', '', [rfReplaceAll]);
  s := StringReplace(s, '<sup>3</sup>', '', [rfReplaceAll]);
end;

procedure SchreibeTagFarbig(e: Trichedit; const wort: string; farbe:TColor);
var
  EndSearch: boolean;
  FoundAt, bis, altselstart, zaehl : integer;
begin
  e.DefAttributes.Color:=clBlack;
  e.DefAttributes.Style:=[];
  with e do Begin
    altselstart := e.selstart;
    EndSearch:=False;
    SelStart:=0;
    SelLength:=0;
    zaehl := 0;
    while not EndSearch do BEgin
      FoundAt:=FindText(wort, SelStart, Length(e.text), []);
      if FoundAt <> -1 then  BEGin
        inc(zaehl);
        if zaehl mod 250 =0 then
          if MessageDlg('Weitermachen oder abbrechen?', mtConfirmation , mbOKCancel,0)
            = mrCancel then exit;
        SelStart:=FoundAt;
        if pos('>',wort) > 0 then bis := length(wort) else Begin
          bis := 1;
          while (bis < 240) and (foundat + bis < length(e.text) ) and
            (e.text[foundat + bis] <> '>') do inc(bis);
        End;
        SelLength:=bis; //Length(wort);
        SelAttributes.Color:=farbe;
        SelAttributes.Style:=[fsBold];
        SelStart:=SelStart + 1;
      END else EndSearch:=True;
    ENd;
  e.SelStart := altselstart;
  End;
end;

function MindestensNspacesAmAnfang(const s: string; n: integer): string;
begin
  result := s;
  while copy(result,1,n) <> copy(spaces40,1,n) do result := ' ' +result;
end;

function RueckeEin(const s: string; const wort: string; const n: Integer): string;
  var pu: Tstringlist;
       k: integer;
begin
  pu := Tstringlist.Create;
  try
    pu.text := s;
    for k := 0 to pu.Count - 1 do
      if pos(lowercase(wort),lowercase(pu[k])) > 0 then Begin
      pu[k] := MindestensNspacesAmAnfang(pu[k],n);
    End;
    result := pu.Text;
  finally pu.free End;
end;

procedure HTML_table_eingerueckt(e: Trichedit);
begin
   e.text := RueckeEin(e.text,'<tr',2);
   e.text := RueckeEin(e.text,'</tr',2);
   e.text := RueckeEin(e.text,'<td',4);
   e.text := RueckeEin(e.text,'</td',4);
   e.text := RueckeEin(e.text,'<th',4);
   e.text := RueckeEin(e.text,'</th',4);
end;

procedure HTML_listen_eingerueckt(e: Trichedit);
begin
   e.text := RueckeEin(e.text,'<li',2);
   e.text := RueckeEin(e.text,'</li',2);
   e.text := RueckeEin(e.text,'<dd',2);
   e.text := RueckeEin(e.text,'</dd',2);
end;

procedure HTML_links_farbig(e: Trichedit);
begin
   SchreibeTagFarbig(e,'<a href',clblue);
   SchreibeTagFarbig(e,'</a>',clblue);
   SchreibeTagFarbig(e,'<img',$00FF8080);
end;

procedure HTML_pre_farbig(e: Trichedit);
begin
   SchreibeTagFarbig(e,'<pre',clfuchsia);
   SchreibeTagFarbig(e,'</pre>',clfuchsia);
end;

procedure HTML_table_farbig(e: Trichedit);
  const dunkelrot = $000000C1;
        rot = clred;
        hellrot = $003E3EFF;
begin
   SchreibeTagFarbig(e,'<table',dunkelrot);
   SchreibeTagFarbig(e,'/table>',dunkelrot);
   SchreibeTagFarbig(e,'<tr',clred);
   SchreibeTagFarbig(e,'/tr>',clred);
   SchreibeTagFarbig(e,'<td',hellrot);
   SchreibeTagFarbig(e,'</td>',hellrot);
   SchreibeTagFarbig(e,'<th',hellrot);
   SchreibeTagFarbig(e,'</th>',hellrot);
end;

procedure HTML_listen_farbig(e: Trichedit);
  const dunkelrot = $000000C1;
        rot = clred;
        hellrot = $003E3EFF;
begin
   SchreibeTagFarbig(e,'<ul',dunkelrot);
   SchreibeTagFarbig(e,'/ul>',dunkelrot);
   SchreibeTagFarbig(e,'<li',clred);
   SchreibeTagFarbig(e,'/li>',clred);
   SchreibeTagFarbig(e,'<ol',hellrot);
   SchreibeTagFarbig(e,'</ol>',hellrot);
   SchreibeTagFarbig(e,'<dl',hellrot);
   SchreibeTagFarbig(e,'</dl>',hellrot);
   SchreibeTagFarbig(e,'<dd',hellrot);
   SchreibeTagFarbig(e,'</dd>',hellrot);
end;


end.
