{$I DebuggerAnAus.pas}
unit InstanceManager; //nach Evan Simpson - esimpson@eramp.net
{ Diese unit Einbinden:
  in .dpr  und unit1.pas als erstes: "uses  InstanceManager"
  und in Form1 folgendes Einfgen
" private
    procedure Nachrichauswerten;
procedure TForm1.Nachrichauswerten; Siehe in unit1 die aktuelle Prozedur!!!
begin
  Application.Restore;
  Application.BringToFront;
  //edit1.Text := WoherKommtDieNachricht; zum Beispiel
  //edit2.text := DieNachrichtselbst;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  InstanceManager.triggerProc:=Nachrichauswerten;
end;"

Siehe dann: Nachladen in teiledenStringInzweiTeile

------------------------------------------Das ist alles!}


interface


const MutexIdentifizierung = 'TTText (c) Joachim Mohr';
      AppNotifyValue: integer = 0;

var WoherKommtDieNachricht,DieNachrichtselbst: string;
    rcvValue: integer;
    ForbidOtherInstance: boolean = True;
    triggerProc: procedure of object;

implementation

uses Windows, SysUtils, Messages;

var mutex, thisWnd: HWND;
    IMWndClass: TWndClassA;
    mustHalt: boolean;
    copydata: TCOPYDATASTRUCT;

function copyab(const s: string; const i: integer): string;
begin result := copy(s, i, length(s) - i + 1) end;

procedure teiledenStringInzweiTeile(var a,b: string);
  var k: integer;
begin
  k := 1;
  while (k < length(a)) and (a[k] <> ' ') do inc(k);
  b := copyab(a,k+1);
  a := copy(a,1,k-1);
end;

function IMWndProc(HWindow: HWnd; Message, WParam: Longint; LParam: Longint): Longint; stdcall;
begin
  if Message=WM_COPYDATA then
    begin
      WoherKommtDieNachricht := StrPas(PCOPYDATASTRUCT(lParam).lpData);
      teiledenStringInzweiTeile(WoherKommtDieNachricht,DieNachrichtSelbst);
      rcvValue := PCOPYDATASTRUCT(lParam).dwData;
      if Assigned(triggerProc) then triggerProc;
      Result := Ord(ForbidOtherInstance);
    end
  else
    Result := DefWindowProc(hWindow, Message, WParam, LParam);
end;

initialization
  FillChar(IMWndClass, SizeOf(IMWndClass), 0);
  IMWndClass.lpfnWndProc := @IMWndProc;
  IMWndClass.hInstance := HINSTANCE;
  IMwndClass.lpszClassName := 'TInstanceManager';
  if Windows.RegisterClass(IMWndClass) = 0 then RaiseLastWin32Error;
  mutex := CreateMutex(nil, True, MutexIdentifizierung);
  if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      mustHalt := True;
      if WaitForSingleObject(mutex, 5000)=WAIT_OBJECT_0 then
        begin
          thisWnd := FindWindow(IMwndClass.lpszClassName, MutexIdentifizierung);
          if thisWnd = 0 then RaiseLastWin32Error;
          CopyData.dwData := AppNotifyValue;
          CopyData.lpData := CmdLine;
          CopyData.cbData := StrLen(CmdLine);
          mustHalt := (SendMessage(thisWnd,WM_COPYDATA,0,Integer(@CopyData))>0);
        end;
      thisWnd := 0;
      ReleaseMutex(mutex);
      if mustHalt then Halt;
    end
  else
    begin
      thisWnd := CreateWindow(IMwndClass.lpszClassName,MutexIdentifizierung,0,0,0,0,0,0,0,hInstance, nil);
      if thisWnd = 0 then RaiseLastWin32Error;
      ReleaseMutex(mutex);
    end;

finalization
  if thisWnd>0 then DestroyWindow(thisWnd);
end.

